import { getEndpointPlugin } from "@aws-sdk/middleware-endpoint";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetCustomVerificationEmailTemplateRequestFilterSensitiveLog, GetCustomVerificationEmailTemplateResponseFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_queryGetCustomVerificationEmailTemplateCommand, serializeAws_queryGetCustomVerificationEmailTemplateCommand, } from "../protocols/Aws_query";
export class GetCustomVerificationEmailTemplateCommand extends $Command {
    constructor(input) {
        super();
        this.input = input;
    }
    static getEndpointParameterInstructions() {
        return {
            UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
            Endpoint: { type: "builtInParams", name: "endpoint" },
            Region: { type: "builtInParams", name: "region" },
            UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" },
        };
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointPlugin(configuration, GetCustomVerificationEmailTemplateCommand.getEndpointParameterInstructions()));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "SESClient";
        const commandName = "GetCustomVerificationEmailTemplateCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: GetCustomVerificationEmailTemplateRequestFilterSensitiveLog,
            outputFilterSensitiveLog: GetCustomVerificationEmailTemplateResponseFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return serializeAws_queryGetCustomVerificationEmailTemplateCommand(input, context);
    }
    deserialize(output, context) {
        return deserializeAws_queryGetCustomVerificationEmailTemplateCommand(output, context);
    }
}
