import { getEndpointPlugin } from "@aws-sdk/middleware-endpoint";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { SetReceiptRulePositionRequestFilterSensitiveLog, SetReceiptRulePositionResponseFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_querySetReceiptRulePositionCommand, serializeAws_querySetReceiptRulePositionCommand, } from "../protocols/Aws_query";
export class SetReceiptRulePositionCommand extends $Command {
    constructor(input) {
        super();
        this.input = input;
    }
    static getEndpointParameterInstructions() {
        return {
            UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
            Endpoint: { type: "builtInParams", name: "endpoint" },
            Region: { type: "builtInParams", name: "region" },
            UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" },
        };
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointPlugin(configuration, SetReceiptRulePositionCommand.getEndpointParameterInstructions()));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "SESClient";
        const commandName = "SetReceiptRulePositionCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: SetReceiptRulePositionRequestFilterSensitiveLog,
            outputFilterSensitiveLog: SetReceiptRulePositionResponseFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return serializeAws_querySetReceiptRulePositionCommand(input, context);
    }
    deserialize(output, context) {
        return deserializeAws_querySetReceiptRulePositionCommand(output, context);
    }
}
