import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import {
  CloneReceiptRuleSetCommandInput,
  CloneReceiptRuleSetCommandOutput,
} from "../commands/CloneReceiptRuleSetCommand";
import {
  CreateConfigurationSetCommandInput,
  CreateConfigurationSetCommandOutput,
} from "../commands/CreateConfigurationSetCommand";
import {
  CreateConfigurationSetEventDestinationCommandInput,
  CreateConfigurationSetEventDestinationCommandOutput,
} from "../commands/CreateConfigurationSetEventDestinationCommand";
import {
  CreateConfigurationSetTrackingOptionsCommandInput,
  CreateConfigurationSetTrackingOptionsCommandOutput,
} from "../commands/CreateConfigurationSetTrackingOptionsCommand";
import {
  CreateCustomVerificationEmailTemplateCommandInput,
  CreateCustomVerificationEmailTemplateCommandOutput,
} from "../commands/CreateCustomVerificationEmailTemplateCommand";
import {
  CreateReceiptFilterCommandInput,
  CreateReceiptFilterCommandOutput,
} from "../commands/CreateReceiptFilterCommand";
import {
  CreateReceiptRuleCommandInput,
  CreateReceiptRuleCommandOutput,
} from "../commands/CreateReceiptRuleCommand";
import {
  CreateReceiptRuleSetCommandInput,
  CreateReceiptRuleSetCommandOutput,
} from "../commands/CreateReceiptRuleSetCommand";
import {
  CreateTemplateCommandInput,
  CreateTemplateCommandOutput,
} from "../commands/CreateTemplateCommand";
import {
  DeleteConfigurationSetCommandInput,
  DeleteConfigurationSetCommandOutput,
} from "../commands/DeleteConfigurationSetCommand";
import {
  DeleteConfigurationSetEventDestinationCommandInput,
  DeleteConfigurationSetEventDestinationCommandOutput,
} from "../commands/DeleteConfigurationSetEventDestinationCommand";
import {
  DeleteConfigurationSetTrackingOptionsCommandInput,
  DeleteConfigurationSetTrackingOptionsCommandOutput,
} from "../commands/DeleteConfigurationSetTrackingOptionsCommand";
import {
  DeleteCustomVerificationEmailTemplateCommandInput,
  DeleteCustomVerificationEmailTemplateCommandOutput,
} from "../commands/DeleteCustomVerificationEmailTemplateCommand";
import {
  DeleteIdentityCommandInput,
  DeleteIdentityCommandOutput,
} from "../commands/DeleteIdentityCommand";
import {
  DeleteIdentityPolicyCommandInput,
  DeleteIdentityPolicyCommandOutput,
} from "../commands/DeleteIdentityPolicyCommand";
import {
  DeleteReceiptFilterCommandInput,
  DeleteReceiptFilterCommandOutput,
} from "../commands/DeleteReceiptFilterCommand";
import {
  DeleteReceiptRuleCommandInput,
  DeleteReceiptRuleCommandOutput,
} from "../commands/DeleteReceiptRuleCommand";
import {
  DeleteReceiptRuleSetCommandInput,
  DeleteReceiptRuleSetCommandOutput,
} from "../commands/DeleteReceiptRuleSetCommand";
import {
  DeleteTemplateCommandInput,
  DeleteTemplateCommandOutput,
} from "../commands/DeleteTemplateCommand";
import {
  DeleteVerifiedEmailAddressCommandInput,
  DeleteVerifiedEmailAddressCommandOutput,
} from "../commands/DeleteVerifiedEmailAddressCommand";
import {
  DescribeActiveReceiptRuleSetCommandInput,
  DescribeActiveReceiptRuleSetCommandOutput,
} from "../commands/DescribeActiveReceiptRuleSetCommand";
import {
  DescribeConfigurationSetCommandInput,
  DescribeConfigurationSetCommandOutput,
} from "../commands/DescribeConfigurationSetCommand";
import {
  DescribeReceiptRuleCommandInput,
  DescribeReceiptRuleCommandOutput,
} from "../commands/DescribeReceiptRuleCommand";
import {
  DescribeReceiptRuleSetCommandInput,
  DescribeReceiptRuleSetCommandOutput,
} from "../commands/DescribeReceiptRuleSetCommand";
import {
  GetAccountSendingEnabledCommandInput,
  GetAccountSendingEnabledCommandOutput,
} from "../commands/GetAccountSendingEnabledCommand";
import {
  GetCustomVerificationEmailTemplateCommandInput,
  GetCustomVerificationEmailTemplateCommandOutput,
} from "../commands/GetCustomVerificationEmailTemplateCommand";
import {
  GetIdentityDkimAttributesCommandInput,
  GetIdentityDkimAttributesCommandOutput,
} from "../commands/GetIdentityDkimAttributesCommand";
import {
  GetIdentityMailFromDomainAttributesCommandInput,
  GetIdentityMailFromDomainAttributesCommandOutput,
} from "../commands/GetIdentityMailFromDomainAttributesCommand";
import {
  GetIdentityNotificationAttributesCommandInput,
  GetIdentityNotificationAttributesCommandOutput,
} from "../commands/GetIdentityNotificationAttributesCommand";
import {
  GetIdentityPoliciesCommandInput,
  GetIdentityPoliciesCommandOutput,
} from "../commands/GetIdentityPoliciesCommand";
import {
  GetIdentityVerificationAttributesCommandInput,
  GetIdentityVerificationAttributesCommandOutput,
} from "../commands/GetIdentityVerificationAttributesCommand";
import {
  GetSendQuotaCommandInput,
  GetSendQuotaCommandOutput,
} from "../commands/GetSendQuotaCommand";
import {
  GetSendStatisticsCommandInput,
  GetSendStatisticsCommandOutput,
} from "../commands/GetSendStatisticsCommand";
import {
  GetTemplateCommandInput,
  GetTemplateCommandOutput,
} from "../commands/GetTemplateCommand";
import {
  ListConfigurationSetsCommandInput,
  ListConfigurationSetsCommandOutput,
} from "../commands/ListConfigurationSetsCommand";
import {
  ListCustomVerificationEmailTemplatesCommandInput,
  ListCustomVerificationEmailTemplatesCommandOutput,
} from "../commands/ListCustomVerificationEmailTemplatesCommand";
import {
  ListIdentitiesCommandInput,
  ListIdentitiesCommandOutput,
} from "../commands/ListIdentitiesCommand";
import {
  ListIdentityPoliciesCommandInput,
  ListIdentityPoliciesCommandOutput,
} from "../commands/ListIdentityPoliciesCommand";
import {
  ListReceiptFiltersCommandInput,
  ListReceiptFiltersCommandOutput,
} from "../commands/ListReceiptFiltersCommand";
import {
  ListReceiptRuleSetsCommandInput,
  ListReceiptRuleSetsCommandOutput,
} from "../commands/ListReceiptRuleSetsCommand";
import {
  ListTemplatesCommandInput,
  ListTemplatesCommandOutput,
} from "../commands/ListTemplatesCommand";
import {
  ListVerifiedEmailAddressesCommandInput,
  ListVerifiedEmailAddressesCommandOutput,
} from "../commands/ListVerifiedEmailAddressesCommand";
import {
  PutConfigurationSetDeliveryOptionsCommandInput,
  PutConfigurationSetDeliveryOptionsCommandOutput,
} from "../commands/PutConfigurationSetDeliveryOptionsCommand";
import {
  PutIdentityPolicyCommandInput,
  PutIdentityPolicyCommandOutput,
} from "../commands/PutIdentityPolicyCommand";
import {
  ReorderReceiptRuleSetCommandInput,
  ReorderReceiptRuleSetCommandOutput,
} from "../commands/ReorderReceiptRuleSetCommand";
import {
  SendBounceCommandInput,
  SendBounceCommandOutput,
} from "../commands/SendBounceCommand";
import {
  SendBulkTemplatedEmailCommandInput,
  SendBulkTemplatedEmailCommandOutput,
} from "../commands/SendBulkTemplatedEmailCommand";
import {
  SendCustomVerificationEmailCommandInput,
  SendCustomVerificationEmailCommandOutput,
} from "../commands/SendCustomVerificationEmailCommand";
import {
  SendEmailCommandInput,
  SendEmailCommandOutput,
} from "../commands/SendEmailCommand";
import {
  SendRawEmailCommandInput,
  SendRawEmailCommandOutput,
} from "../commands/SendRawEmailCommand";
import {
  SendTemplatedEmailCommandInput,
  SendTemplatedEmailCommandOutput,
} from "../commands/SendTemplatedEmailCommand";
import {
  SetActiveReceiptRuleSetCommandInput,
  SetActiveReceiptRuleSetCommandOutput,
} from "../commands/SetActiveReceiptRuleSetCommand";
import {
  SetIdentityDkimEnabledCommandInput,
  SetIdentityDkimEnabledCommandOutput,
} from "../commands/SetIdentityDkimEnabledCommand";
import {
  SetIdentityFeedbackForwardingEnabledCommandInput,
  SetIdentityFeedbackForwardingEnabledCommandOutput,
} from "../commands/SetIdentityFeedbackForwardingEnabledCommand";
import {
  SetIdentityHeadersInNotificationsEnabledCommandInput,
  SetIdentityHeadersInNotificationsEnabledCommandOutput,
} from "../commands/SetIdentityHeadersInNotificationsEnabledCommand";
import {
  SetIdentityMailFromDomainCommandInput,
  SetIdentityMailFromDomainCommandOutput,
} from "../commands/SetIdentityMailFromDomainCommand";
import {
  SetIdentityNotificationTopicCommandInput,
  SetIdentityNotificationTopicCommandOutput,
} from "../commands/SetIdentityNotificationTopicCommand";
import {
  SetReceiptRulePositionCommandInput,
  SetReceiptRulePositionCommandOutput,
} from "../commands/SetReceiptRulePositionCommand";
import {
  TestRenderTemplateCommandInput,
  TestRenderTemplateCommandOutput,
} from "../commands/TestRenderTemplateCommand";
import {
  UpdateAccountSendingEnabledCommandInput,
  UpdateAccountSendingEnabledCommandOutput,
} from "../commands/UpdateAccountSendingEnabledCommand";
import {
  UpdateConfigurationSetEventDestinationCommandInput,
  UpdateConfigurationSetEventDestinationCommandOutput,
} from "../commands/UpdateConfigurationSetEventDestinationCommand";
import {
  UpdateConfigurationSetReputationMetricsEnabledCommandInput,
  UpdateConfigurationSetReputationMetricsEnabledCommandOutput,
} from "../commands/UpdateConfigurationSetReputationMetricsEnabledCommand";
import {
  UpdateConfigurationSetSendingEnabledCommandInput,
  UpdateConfigurationSetSendingEnabledCommandOutput,
} from "../commands/UpdateConfigurationSetSendingEnabledCommand";
import {
  UpdateConfigurationSetTrackingOptionsCommandInput,
  UpdateConfigurationSetTrackingOptionsCommandOutput,
} from "../commands/UpdateConfigurationSetTrackingOptionsCommand";
import {
  UpdateCustomVerificationEmailTemplateCommandInput,
  UpdateCustomVerificationEmailTemplateCommandOutput,
} from "../commands/UpdateCustomVerificationEmailTemplateCommand";
import {
  UpdateReceiptRuleCommandInput,
  UpdateReceiptRuleCommandOutput,
} from "../commands/UpdateReceiptRuleCommand";
import {
  UpdateTemplateCommandInput,
  UpdateTemplateCommandOutput,
} from "../commands/UpdateTemplateCommand";
import {
  VerifyDomainDkimCommandInput,
  VerifyDomainDkimCommandOutput,
} from "../commands/VerifyDomainDkimCommand";
import {
  VerifyDomainIdentityCommandInput,
  VerifyDomainIdentityCommandOutput,
} from "../commands/VerifyDomainIdentityCommand";
import {
  VerifyEmailAddressCommandInput,
  VerifyEmailAddressCommandOutput,
} from "../commands/VerifyEmailAddressCommand";
import {
  VerifyEmailIdentityCommandInput,
  VerifyEmailIdentityCommandOutput,
} from "../commands/VerifyEmailIdentityCommand";
export declare const serializeAws_queryCloneReceiptRuleSetCommand: (
  input: CloneReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateConfigurationSetCommand: (
  input: CreateConfigurationSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateConfigurationSetEventDestinationCommand: (
  input: CreateConfigurationSetEventDestinationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateConfigurationSetTrackingOptionsCommand: (
  input: CreateConfigurationSetTrackingOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateCustomVerificationEmailTemplateCommand: (
  input: CreateCustomVerificationEmailTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateReceiptFilterCommand: (
  input: CreateReceiptFilterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateReceiptRuleCommand: (
  input: CreateReceiptRuleCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateReceiptRuleSetCommand: (
  input: CreateReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryCreateTemplateCommand: (
  input: CreateTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteConfigurationSetCommand: (
  input: DeleteConfigurationSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteConfigurationSetEventDestinationCommand: (
  input: DeleteConfigurationSetEventDestinationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteConfigurationSetTrackingOptionsCommand: (
  input: DeleteConfigurationSetTrackingOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteCustomVerificationEmailTemplateCommand: (
  input: DeleteCustomVerificationEmailTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteIdentityCommand: (
  input: DeleteIdentityCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteIdentityPolicyCommand: (
  input: DeleteIdentityPolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteReceiptFilterCommand: (
  input: DeleteReceiptFilterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteReceiptRuleCommand: (
  input: DeleteReceiptRuleCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteReceiptRuleSetCommand: (
  input: DeleteReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteTemplateCommand: (
  input: DeleteTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteVerifiedEmailAddressCommand: (
  input: DeleteVerifiedEmailAddressCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeActiveReceiptRuleSetCommand: (
  input: DescribeActiveReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeConfigurationSetCommand: (
  input: DescribeConfigurationSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeReceiptRuleCommand: (
  input: DescribeReceiptRuleCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeReceiptRuleSetCommand: (
  input: DescribeReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetAccountSendingEnabledCommand: (
  input: GetAccountSendingEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetCustomVerificationEmailTemplateCommand: (
  input: GetCustomVerificationEmailTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetIdentityDkimAttributesCommand: (
  input: GetIdentityDkimAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetIdentityMailFromDomainAttributesCommand: (
  input: GetIdentityMailFromDomainAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetIdentityNotificationAttributesCommand: (
  input: GetIdentityNotificationAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetIdentityPoliciesCommand: (
  input: GetIdentityPoliciesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetIdentityVerificationAttributesCommand: (
  input: GetIdentityVerificationAttributesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetSendQuotaCommand: (
  input: GetSendQuotaCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetSendStatisticsCommand: (
  input: GetSendStatisticsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetTemplateCommand: (
  input: GetTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListConfigurationSetsCommand: (
  input: ListConfigurationSetsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListCustomVerificationEmailTemplatesCommand: (
  input: ListCustomVerificationEmailTemplatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListIdentitiesCommand: (
  input: ListIdentitiesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListIdentityPoliciesCommand: (
  input: ListIdentityPoliciesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListReceiptFiltersCommand: (
  input: ListReceiptFiltersCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListReceiptRuleSetsCommand: (
  input: ListReceiptRuleSetsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListTemplatesCommand: (
  input: ListTemplatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListVerifiedEmailAddressesCommand: (
  input: ListVerifiedEmailAddressesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutConfigurationSetDeliveryOptionsCommand: (
  input: PutConfigurationSetDeliveryOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutIdentityPolicyCommand: (
  input: PutIdentityPolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryReorderReceiptRuleSetCommand: (
  input: ReorderReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendBounceCommand: (
  input: SendBounceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendBulkTemplatedEmailCommand: (
  input: SendBulkTemplatedEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendCustomVerificationEmailCommand: (
  input: SendCustomVerificationEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendEmailCommand: (
  input: SendEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendRawEmailCommand: (
  input: SendRawEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySendTemplatedEmailCommand: (
  input: SendTemplatedEmailCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetActiveReceiptRuleSetCommand: (
  input: SetActiveReceiptRuleSetCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetIdentityDkimEnabledCommand: (
  input: SetIdentityDkimEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetIdentityFeedbackForwardingEnabledCommand: (
  input: SetIdentityFeedbackForwardingEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetIdentityHeadersInNotificationsEnabledCommand: (
  input: SetIdentityHeadersInNotificationsEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetIdentityMailFromDomainCommand: (
  input: SetIdentityMailFromDomainCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetIdentityNotificationTopicCommand: (
  input: SetIdentityNotificationTopicCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetReceiptRulePositionCommand: (
  input: SetReceiptRulePositionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryTestRenderTemplateCommand: (
  input: TestRenderTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateAccountSendingEnabledCommand: (
  input: UpdateAccountSendingEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateConfigurationSetEventDestinationCommand: (
  input: UpdateConfigurationSetEventDestinationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateConfigurationSetReputationMetricsEnabledCommand: (
  input: UpdateConfigurationSetReputationMetricsEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateConfigurationSetSendingEnabledCommand: (
  input: UpdateConfigurationSetSendingEnabledCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateConfigurationSetTrackingOptionsCommand: (
  input: UpdateConfigurationSetTrackingOptionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateCustomVerificationEmailTemplateCommand: (
  input: UpdateCustomVerificationEmailTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateReceiptRuleCommand: (
  input: UpdateReceiptRuleCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUpdateTemplateCommand: (
  input: UpdateTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryVerifyDomainDkimCommand: (
  input: VerifyDomainDkimCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryVerifyDomainIdentityCommand: (
  input: VerifyDomainIdentityCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryVerifyEmailAddressCommand: (
  input: VerifyEmailAddressCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryVerifyEmailIdentityCommand: (
  input: VerifyEmailIdentityCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const deserializeAws_queryCloneReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CloneReceiptRuleSetCommandOutput>;
export declare const deserializeAws_queryCreateConfigurationSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateConfigurationSetCommandOutput>;
export declare const deserializeAws_queryCreateConfigurationSetEventDestinationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateConfigurationSetEventDestinationCommandOutput>;
export declare const deserializeAws_queryCreateConfigurationSetTrackingOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateConfigurationSetTrackingOptionsCommandOutput>;
export declare const deserializeAws_queryCreateCustomVerificationEmailTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateCustomVerificationEmailTemplateCommandOutput>;
export declare const deserializeAws_queryCreateReceiptFilterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateReceiptFilterCommandOutput>;
export declare const deserializeAws_queryCreateReceiptRuleCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateReceiptRuleCommandOutput>;
export declare const deserializeAws_queryCreateReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateReceiptRuleSetCommandOutput>;
export declare const deserializeAws_queryCreateTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateTemplateCommandOutput>;
export declare const deserializeAws_queryDeleteConfigurationSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteConfigurationSetCommandOutput>;
export declare const deserializeAws_queryDeleteConfigurationSetEventDestinationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteConfigurationSetEventDestinationCommandOutput>;
export declare const deserializeAws_queryDeleteConfigurationSetTrackingOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteConfigurationSetTrackingOptionsCommandOutput>;
export declare const deserializeAws_queryDeleteCustomVerificationEmailTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteCustomVerificationEmailTemplateCommandOutput>;
export declare const deserializeAws_queryDeleteIdentityCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteIdentityCommandOutput>;
export declare const deserializeAws_queryDeleteIdentityPolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteIdentityPolicyCommandOutput>;
export declare const deserializeAws_queryDeleteReceiptFilterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteReceiptFilterCommandOutput>;
export declare const deserializeAws_queryDeleteReceiptRuleCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteReceiptRuleCommandOutput>;
export declare const deserializeAws_queryDeleteReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteReceiptRuleSetCommandOutput>;
export declare const deserializeAws_queryDeleteTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteTemplateCommandOutput>;
export declare const deserializeAws_queryDeleteVerifiedEmailAddressCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteVerifiedEmailAddressCommandOutput>;
export declare const deserializeAws_queryDescribeActiveReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeActiveReceiptRuleSetCommandOutput>;
export declare const deserializeAws_queryDescribeConfigurationSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeConfigurationSetCommandOutput>;
export declare const deserializeAws_queryDescribeReceiptRuleCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeReceiptRuleCommandOutput>;
export declare const deserializeAws_queryDescribeReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeReceiptRuleSetCommandOutput>;
export declare const deserializeAws_queryGetAccountSendingEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAccountSendingEnabledCommandOutput>;
export declare const deserializeAws_queryGetCustomVerificationEmailTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetCustomVerificationEmailTemplateCommandOutput>;
export declare const deserializeAws_queryGetIdentityDkimAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIdentityDkimAttributesCommandOutput>;
export declare const deserializeAws_queryGetIdentityMailFromDomainAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIdentityMailFromDomainAttributesCommandOutput>;
export declare const deserializeAws_queryGetIdentityNotificationAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIdentityNotificationAttributesCommandOutput>;
export declare const deserializeAws_queryGetIdentityPoliciesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIdentityPoliciesCommandOutput>;
export declare const deserializeAws_queryGetIdentityVerificationAttributesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIdentityVerificationAttributesCommandOutput>;
export declare const deserializeAws_queryGetSendQuotaCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSendQuotaCommandOutput>;
export declare const deserializeAws_queryGetSendStatisticsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSendStatisticsCommandOutput>;
export declare const deserializeAws_queryGetTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetTemplateCommandOutput>;
export declare const deserializeAws_queryListConfigurationSetsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListConfigurationSetsCommandOutput>;
export declare const deserializeAws_queryListCustomVerificationEmailTemplatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListCustomVerificationEmailTemplatesCommandOutput>;
export declare const deserializeAws_queryListIdentitiesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListIdentitiesCommandOutput>;
export declare const deserializeAws_queryListIdentityPoliciesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListIdentityPoliciesCommandOutput>;
export declare const deserializeAws_queryListReceiptFiltersCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListReceiptFiltersCommandOutput>;
export declare const deserializeAws_queryListReceiptRuleSetsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListReceiptRuleSetsCommandOutput>;
export declare const deserializeAws_queryListTemplatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTemplatesCommandOutput>;
export declare const deserializeAws_queryListVerifiedEmailAddressesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListVerifiedEmailAddressesCommandOutput>;
export declare const deserializeAws_queryPutConfigurationSetDeliveryOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutConfigurationSetDeliveryOptionsCommandOutput>;
export declare const deserializeAws_queryPutIdentityPolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutIdentityPolicyCommandOutput>;
export declare const deserializeAws_queryReorderReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ReorderReceiptRuleSetCommandOutput>;
export declare const deserializeAws_querySendBounceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendBounceCommandOutput>;
export declare const deserializeAws_querySendBulkTemplatedEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendBulkTemplatedEmailCommandOutput>;
export declare const deserializeAws_querySendCustomVerificationEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendCustomVerificationEmailCommandOutput>;
export declare const deserializeAws_querySendEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendEmailCommandOutput>;
export declare const deserializeAws_querySendRawEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendRawEmailCommandOutput>;
export declare const deserializeAws_querySendTemplatedEmailCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SendTemplatedEmailCommandOutput>;
export declare const deserializeAws_querySetActiveReceiptRuleSetCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetActiveReceiptRuleSetCommandOutput>;
export declare const deserializeAws_querySetIdentityDkimEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetIdentityDkimEnabledCommandOutput>;
export declare const deserializeAws_querySetIdentityFeedbackForwardingEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetIdentityFeedbackForwardingEnabledCommandOutput>;
export declare const deserializeAws_querySetIdentityHeadersInNotificationsEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetIdentityHeadersInNotificationsEnabledCommandOutput>;
export declare const deserializeAws_querySetIdentityMailFromDomainCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetIdentityMailFromDomainCommandOutput>;
export declare const deserializeAws_querySetIdentityNotificationTopicCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetIdentityNotificationTopicCommandOutput>;
export declare const deserializeAws_querySetReceiptRulePositionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetReceiptRulePositionCommandOutput>;
export declare const deserializeAws_queryTestRenderTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TestRenderTemplateCommandOutput>;
export declare const deserializeAws_queryUpdateAccountSendingEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateAccountSendingEnabledCommandOutput>;
export declare const deserializeAws_queryUpdateConfigurationSetEventDestinationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateConfigurationSetEventDestinationCommandOutput>;
export declare const deserializeAws_queryUpdateConfigurationSetReputationMetricsEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateConfigurationSetReputationMetricsEnabledCommandOutput>;
export declare const deserializeAws_queryUpdateConfigurationSetSendingEnabledCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateConfigurationSetSendingEnabledCommandOutput>;
export declare const deserializeAws_queryUpdateConfigurationSetTrackingOptionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateConfigurationSetTrackingOptionsCommandOutput>;
export declare const deserializeAws_queryUpdateCustomVerificationEmailTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateCustomVerificationEmailTemplateCommandOutput>;
export declare const deserializeAws_queryUpdateReceiptRuleCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateReceiptRuleCommandOutput>;
export declare const deserializeAws_queryUpdateTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateTemplateCommandOutput>;
export declare const deserializeAws_queryVerifyDomainDkimCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<VerifyDomainDkimCommandOutput>;
export declare const deserializeAws_queryVerifyDomainIdentityCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<VerifyDomainIdentityCommandOutput>;
export declare const deserializeAws_queryVerifyEmailAddressCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<VerifyEmailAddressCommandOutput>;
export declare const deserializeAws_queryVerifyEmailIdentityCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<VerifyEmailIdentityCommandOutput>;
