import{a as o,o as r,e as h,y as e,u as s,q as t,z as a}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},p=s("hr",null,null,-1),u=s("h2",{id:"the-activity-object",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#the-activity-object"},"#"),t(" The Activity Object")],-1),_=s("p",null,[s("code",null,"action"),t(),s("strong",null,"string"),s("br"),t(" Action that was performed.")],-1),m=s("p",null,[s("code",null,"collection"),t(),s("strong",null,"string"),s("br"),t(" Collection identifier in which the item resides.")],-1),y=s("p",null,[s("code",null,"comment"),t(),s("strong",null,"string"),s("br"),t(" User comment. This will store the comments that show up in the right sidebar of the item edit page in the admin app.")],-1),g=s("p",null,[s("code",null,"id"),t(),s("strong",null,"integer"),s("br"),t(" Unique identifier for the object.")],-1),j=s("p",null,[s("code",null,"ip"),t(),s("strong",null,"string"),s("br"),t(" The IP address of the user at the time the action took place.")],-1),b=s("p",null,[s("code",null,"item"),t(),s("strong",null,"string"),s("br"),t(" Unique identifier for the item the action applied to. This is always a string, even for integer primary keys.")],-1),f=s("p",null,[s("code",null,"timestamp"),t(),s("strong",null,"string"),s("br"),t(" When the action happened.")],-1),v=s("code",null,"user",-1),x=s("strong",null,"many-to-one",-1),q=s("br",null,null,-1),w=s("p",null,[s("code",null,"user_agent"),t(),s("strong",null,"string"),s("br"),t(" User agent string of the browser the user used when the action took place.")],-1),T=s("code",null,"revisions",-1),k=s("strong",null,"one-to-many",-1),E=s("br",null,null,-1),A=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-punctuation"},"{"),t(`
	`),s("span",{class:"hljs-attr"},'"action"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"create"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"collection"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"articles"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"comment"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"id"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"5"),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"ip"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"139.178.128.0"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"item"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"1"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"timestamp"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"2021-02-02T12:50:26-05:00"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"user"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"2d321940-69f5-445f-be6b-c773fa58a820"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"user_agent"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/14.0.2 Safari/605.1.15"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"revisions"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-punctuation"},"["),s("span",{class:"hljs-number"},"4"),s("span",{class:"hljs-punctuation"},"]"),t(`
`),s("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),R=s("hr",null,null,-1),S=s("h2",{id:"list-activity-actions",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#list-activity-actions"},"#"),t(" List Activity Actions")],-1),P=s("p",null,"Returns a list of activity actions.",-1),C=s("h3",{id:"query-parameters",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters"},"#"),t(" Query Parameters")],-1),I=s("h3",{id:"returns",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns"},"#"),t(" Returns")],-1),L=s("a",{href:"#the-activity-object"},"activity objects",-1),D=s("h3",{id:"rest-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api"},"#"),t(" REST API")],-1),Q=s("pre",null,[s("code",null,`GET /activity
SEARCH /activity
`)],-1),G=s("h3",{id:"graphql",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql"},"#"),t(" GraphQL")],-1),M=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),O=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),t(` {
	activity: [directus_activity]
}
`)])],-1),H=s("h5",{id:"example",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example"},"#"),t(" Example")],-1),U=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),t(` {
	activity {
		`),s("span",{class:"hljs-keyword"},"..."),t(`
	}
}
`)])],-1),W=s("hr",null,null,-1),B=s("h2",{id:"retrieve-activity-action",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#retrieve-activity-action"},"#"),t(" Retrieve Activity Action")],-1),V=s("p",null,"Returns a single activity action by primary key.",-1),K=s("h3",{id:"query-parameters-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-1"},"#"),t(" Query Parameters")],-1),N=s("h3",{id:"returns-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-1"},"#"),t(" Returns")],-1),z=s("p",null,[t("Returns an "),s("a",{href:"#the-activity-object"},"activity object"),t(" if a valid identifier was provided.")],-1),X=s("h3",{id:"rest-api-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-1"},"#"),t(" REST API")],-1),F=s("pre",null,[s("code",null,`GET /activity/:id
`)],-1),J=s("h3",{id:"graphql-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-1"},"#"),t(" GraphQL")],-1),Y=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Z=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),t(` {
	activity_by_id(id:`),s("span",{class:"hljs-literal"}," ID"),t(`!): directus_activity
}
`)])],-1),$=s("h5",{id:"example-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-1"},"#"),t(" Example")],-1),ss=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),t(` {
	activity_by_id(id: `),s("span",{class:"hljs-number"},"15"),t(`) {
		`),s("span",{class:"hljs-keyword"},"..."),t(`
	}
}
`)])],-1),ts=s("hr",null,null,-1),es=s("h2",{id:"create-a-comment",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#create-a-comment"},"#"),t(" Create a Comment")],-1),ns=s("p",null,"Creates a new comment on a given item.",-1),as=s("h3",{id:"request-body",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body"},"#"),t(" Request Body")],-1),ls=s("p",null,[s("code",null,"collection"),t(),s("strong",null,"Required"),s("br"),t(" Collection in which the item resides.")],-1),os=s("p",null,[s("code",null,"item"),t(),s("strong",null,"Required"),s("br"),t(" Primary Key of the item to comment on.")],-1),cs=s("p",null,[s("code",null,"comment"),t(),s("strong",null,"Required"),s("br"),t(" The comment content. Supports Markdown.")],-1),is=s("h3",{id:"returns-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-2"},"#"),t(" Returns")],-1),rs=s("p",null,[t("Returns the "),s("a",{href:"#the-activity-object"},"activity object"),t(" of the created comment.")],-1),hs=s("h3",{id:"rest-api-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-2"},"#"),t(" REST API")],-1),ds=s("pre",null,[s("code",null,`POST /activity/comment
`)],-1),ps=s("h5",{id:"example-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-2"},"#"),t(" Example")],-1),us=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// POST /activity/comment"),t(`

`),s("span",{class:"hljs-punctuation"},"{"),t(`
	`),s("span",{class:"hljs-attr"},'"collection"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"pages"'),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"item"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-number"},"3"),s("span",{class:"hljs-punctuation"},","),t(`
	`),s("span",{class:"hljs-attr"},'"comment"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Hello World"'),t(`
`),s("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),_s=s("h3",{id:"graphql-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-2"},"#"),t(" GraphQL")],-1),ms=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),ys=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),t(` {
	create_comment(collection:`),s("span",{class:"hljs-type"}," String"),t("!, item:"),s("span",{class:"hljs-literal"}," ID"),t("!, comment:"),s("span",{class:"hljs-type"}," String"),t(`!): directus_activity
}
`)])],-1),gs=s("h5",{id:"example-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-3"},"#"),t(" Example")],-1),js=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),t(` {
	create_comment(
		collection: `),s("span",{class:"hljs-string"},'"pages"'),t(`,
		item: `),s("span",{class:"hljs-number"},"3"),t(`,
		comment: `),s("span",{class:"hljs-string"},'"Hello World"'),t(`
	) { `),s("span",{class:"hljs-keyword"},"..."),t(` }
}
`)])],-1),bs=s("hr",null,null,-1),fs=s("h2",{id:"update-a-comment",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#update-a-comment"},"#"),t(" Update a Comment")],-1),vs=s("p",null,"Updates an existing comment by activity action primary key.",-1),xs=s("h3",{id:"request-body-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-1"},"#"),t(" Request Body")],-1),qs=s("p",null,[s("code",null,"comment"),t(),s("strong",null,"Required"),s("br"),t(" The updated comment content. Supports Markdown.")],-1),ws=s("h3",{id:"returns-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-3"},"#"),t(" Returns")],-1),Ts=s("p",null,[t("Returns the "),s("a",{href:"#the-activity-object"},"activity object"),t(" of the created comment.")],-1),ks=s("h3",{id:"rest-api-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-3"},"#"),t(" REST API")],-1),Es=s("pre",null,[s("code",null,`PATCH /activity/comment/:id
`)],-1),As=s("h5",{id:"example-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-4"},"#"),t(" Example")],-1),Rs=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// PATCH /activity/comment/15"),t(`

`),s("span",{class:"hljs-punctuation"},"{"),t(`
	`),s("span",{class:"hljs-attr"},'"comment"'),s("span",{class:"hljs-punctuation"},":"),t(),s("span",{class:"hljs-string"},'"Hello World!!"'),t(`
`),s("span",{class:"hljs-punctuation"},"}"),t(`
`)])],-1),Ss=s("h3",{id:"graphql-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-3"},"#"),t(" GraphQL")],-1),Ps=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Cs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),t(` {
	update_comment(id:`),s("span",{class:"hljs-literal"}," ID"),t("!, comment:"),s("span",{class:"hljs-type"}," String"),t(`!): directus_activity
}
`)])],-1),Is=s("h5",{id:"example-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-5"},"#"),t(" Example")],-1),Ls=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),t(` {
	update_comment(
		id: `),s("span",{class:"hljs-number"},"3"),t(`,
		comment: `),s("span",{class:"hljs-string"},'"Hello World"'),t(`,
	) { `),s("span",{class:"hljs-keyword"},"..."),t(` }
}
`)])],-1),Ds=s("hr",null,null,-1),Qs=s("h2",{id:"delete-a-comment",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#delete-a-comment"},"#"),t(" Delete a Comment")],-1),Gs=s("p",null,"Deletes a comment.",-1),Ms=s("h3",{id:"rest-api-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-4"},"#"),t(" REST API")],-1),Os=s("pre",null,[s("code",null,`DELETE /activity/comment/:id
`)],-1),Hs=s("h5",{id:"example-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-6"},"#"),t(" Example")],-1),Us=s("pre",null,[s("code",null,`DELETE /activity/comment/15
`)],-1),Ws=s("h3",{id:"graphql-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-4"},"#"),t(" GraphQL")],-1),Bs=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Vs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),t(` {
	delete_comment(id:`),s("span",{class:"hljs-literal"}," ID"),t(`): delete_one
}
`)])],-1),Ks=s("h5",{id:"example-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-7"},"#"),t(" Example")],-1),Ns=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),t(` {
	delete_comment(id: `),s("span",{class:"hljs-number"},"3"),t(`) {
		id
	}
}
`)])],-1),Ys="Activity",Zs=!1,$s="REST and GraphQL API documentation on the Activity collection in Directus.",st="4 min read",tt="page-reference",et={__name:"activity",setup(zs,{expose:c}){const l={title:"Activity",modularExtension:!1,description:"REST and GraphQL API documentation on the Activity collection in Directus.",readTime:"4 min read",pageClass:"page-reference"};return c({frontmatter:l}),(Xs,Fs)=>{const n=o("router-link"),i=o("docs-wrapper");return r(),h(i,{frontmatter:l},{default:e(()=>[s("div",d,[s("blockquote",null,[s("p",null,[t("All events within Directus are tracked and stored in the activities collection. This gives you full accountability over everything that happens. "),a(n,{to:"/docs/getting-started/glossary#activity"},{default:e(()=>[t("Learn more about Activity")]),_:1}),t(".")])]),p,u,_,m,y,g,j,b,f,s("p",null,[v,t(),x,q,t(" The user who performed this action. Many-to-one to "),a(n,{to:"/docs/reference/system/users#the-users-object"},{default:e(()=>[t("users")]),_:1}),t(".")]),w,s("p",null,[T,t(),k,E,t(" Any changes that were made in this activity. One-to-many to "),a(n,{to:"/docs/reference/system/revisions#the-revisions-object"},{default:e(()=>[t("revisions")]),_:1}),t(".")]),A,R,S,P,C,s("p",null,[t("Supports all "),a(n,{to:"/docs/reference/query"},{default:e(()=>[t("global query parameters")]),_:1}),t(".")]),I,s("p",null,[t("An array of up to "),a(n,{to:"/docs/reference/query#limit"},{default:e(()=>[t("limit")]),_:1}),t(),L,t(". If no items are available, data will be an empty array.")]),D,Q,s("p",null,[a(n,{to:"/docs/reference/introduction#search-http-method"},{default:e(()=>[t("Learn more about SEARCH ->")]),_:1})]),G,M,O,H,U,W,B,V,K,s("p",null,[t("Supports all "),a(n,{to:"/docs/reference/query"},{default:e(()=>[t("global query parameters")]),_:1}),t(".")]),N,z,X,F,J,Y,Z,$,ss,ts,es,ns,as,ls,os,cs,is,rs,hs,ds,ps,us,_s,ms,ys,gs,js,bs,fs,vs,xs,qs,ws,Ts,ks,Es,As,Rs,Ss,Ps,Cs,Is,Ls,Ds,Qs,Gs,Ms,Os,Hs,Us,Ws,Bs,Vs,Ks,Ns])]),_:1})}}};export{et as default,$s as description,Zs as modularExtension,tt as pageClass,st as readTime,Ys as title};
