import{a,o as r,e as h,y as t,u as s,q as e,z as i}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},p=s("hr",null,null,-1),u=s("h2",{id:"the-field-object",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#the-field-object"},"#"),e(" The Field Object")],-1),_=s("p",null,[s("code",null,"collection"),e(),s("strong",null,"string"),s("br"),e(" Name of the collection the field resides in.")],-1),f=s("p",null,[s("code",null,"field"),e(),s("strong",null,"string"),s("br"),e(" The identifier of the field. This matches the table column name.")],-1),j=s("code",null,"type",-1),g=s("strong",null,"string",-1),m=s("br",null,null,-1),y=s("h4",{id:"meta",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#meta"},"#"),e(" Meta")],-1),b=s("p",null,"Directus metadata, primarily used in the Admin App. Meta is optional.",-1),x=s("p",null,[s("code",null,"id"),e(),s("strong",null,"integer"),s("br"),e(" Primary key of the metadata row in "),s("code",null,"directus_fields"),e(".")],-1),q=s("p",null,[s("code",null,"collection"),e(),s("strong",null,"string"),s("br"),e(" The name of the collection this field resides in.")],-1),T=s("p",null,[s("code",null,"field"),e(),s("strong",null,"string"),s("br"),e(" Identifier of the field. Matches the column name in the database.")],-1),w=s("p",null,[s("code",null,"special"),e(),s("strong",null,"string"),s("br"),e(" Any special transform flags that apply to this field.")],-1),k=s("p",null,[s("code",null,"interface"),e(),s("strong",null,"string"),s("br"),e(" The interface used for this field.")],-1),v=s("p",null,[s("code",null,"options"),e(),s("strong",null,"object"),s("br"),e(" The interface options configured for this field. The structure is based on the interface used.")],-1),A=s("p",null,[s("code",null,"display"),e(),s("strong",null,"string"),s("br"),e(" The display used for this field.")],-1),E=s("p",null,[s("code",null,"display_options"),e(),s("strong",null,"string"),s("br"),e(" The configured options for the used display.")],-1),S=s("p",null,[s("code",null,"readonly"),e(),s("strong",null,"boolean"),s("br"),e(" If the field is considered readonly in the Admin App.")],-1),P=s("p",null,[s("code",null,"hidden"),e(),s("strong",null,"boolean"),s("br"),e(" If the field is hidden from the edit page in the Admin App.")],-1),R=s("p",null,[s("code",null,"sort"),e(),s("strong",null,"integer"),s("br"),e(" Where this field is shown on the edit page in the Admin App.")],-1),Q=s("p",null,[s("code",null,"width"),e(),s("strong",null,"string"),s("br"),e(" How wide the interface is rendered on the edit page in the Admin App. One of "),s("code",null,"half"),e(", "),s("code",null,"half-left"),e(", "),s("code",null,"half-right"),e(", "),s("code",null,"half-space"),e(", "),s("code",null,"full"),e(", "),s("code",null,"fill"),e(".")],-1),I=s("p",null,[s("code",null,"translations"),e(),s("strong",null,"array"),s("br"),e(" How this field\u2019s name is displayed in the different languages in the Admin App.")],-1),L=s("p",null,[s("code",null,"note"),e(),s("strong",null,"string"),s("br"),e(" Short description displayed in the Admin App.")],-1),F=s("h4",{id:"schema",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#schema"},"#"),e(" Schema")],-1),G=s("p",null,"\u201CRaw\u201D database information. Based on the database vendor used, different information might be returned. The following are available for all drivers. Note: schema is optional. If a field exist in directus_fields, but not in the database, it\u2019s an alias commonly used for relational (O2M) or presentation purposes in the Admin App.",-1),C=s("p",null,[s("code",null,"name"),e(),s("strong",null,"string"),s("br"),e(" Identifier of the field. Matches the column name in the database.")],-1),O=s("p",null,[s("code",null,"table"),e(),s("strong",null,"string"),s("br"),e(" Name of the table the column resides in.")],-1),D=s("p",null,[s("code",null,"data_type"),e(),s("strong",null,"string"),s("br"),e(" The datatype as used in the database. Note: this value is database vendor specific.")],-1),H=s("p",null,[s("code",null,"default_value"),e(),s("strong",null,"any"),s("br"),e(" The configured default value for the column.")],-1),M=s("p",null,[s("code",null,"max_length"),e(),s("strong",null,"integer"),s("br"),e(" Configured length for varchar type columns.")],-1),B=s("p",null,[s("code",null,"numeric_precision"),e(),s("strong",null,"integer"),s("br"),e(" Precision for integer/float/decimal type fields.")],-1),N=s("p",null,[s("code",null,"numeric_scale"),e(),s("strong",null,"integer"),s("br"),e(" Scale for integer/float/decimal type fields.")],-1),W=s("p",null,[s("code",null,"is_nullable"),e(),s("strong",null,"boolean"),s("br"),e(" Whether or not the column is nullable. This is what is used as the \u201Crequired\u201D state in Directus.")],-1),U=s("p",null,[s("code",null,"is_primary_key"),e(),s("strong",null,"boolean"),s("br"),e(" Whether or not the field is the primary key of the table.")],-1),V=s("p",null,[s("code",null,"foreign_key_column"),e(),s("strong",null,"string"),s("br"),e(" If the current column has a foreign key constraint, this points to the related column.")],-1),z=s("p",null,[s("code",null,"foreign_key_table"),e(),s("strong",null,"string"),s("br"),e(" If the current column has a foreign key constraint, this points to the related table.")],-1),J=s("p",null,[s("code",null,"comment"),e(),s("strong",null,"string"),s("br"),e(" Comment as stored in the database.")],-1),K=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"collection"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"articles"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"field"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"id"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"type"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"integer"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"meta"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"id"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"16"),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"collection"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"articles"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"field"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"id"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"special"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"interface"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"numeric"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"options"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"display"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"display_options"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"readonly"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"hidden"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"sort"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"1"),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"width"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"full"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"translations"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"note"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"The unique identifier of the article"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"schema"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"name"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"id"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"table"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"articles"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"data_type"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"integer"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"default_value"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"max_length"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"numeric_precision"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"32"),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"numeric_scale"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-number"},"0"),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"is_nullable"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"is_primary_key"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"has_auto_increment"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"foreign_key_column"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"foreign_key_table"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"comment"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),X=s("hr",null,null,-1),Y=s("h2",{id:"list-all-fields",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#list-all-fields"},"#"),e(" List All Fields")],-1),Z=s("p",null,"List the available fields.",-1),$=s("h3",{id:"query-parameters",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters"},"#"),e(" Query Parameters")],-1),ss=s("p",null,"This endpoint doesn\u2019t currently support any query parameters.",-1),es=s("h3",{id:"returns",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns"},"#"),e(" Returns")],-1),ts=s("p",null,[e("An array of "),s("a",{href:"#the-field-object"},"field objects"),e(".")],-1),ns=s("h3",{id:"rest-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api"},"#"),e(" REST API")],-1),ls=s("pre",null,[s("code",null,`GET /fields
`)],-1),as=s("h3",{id:"graphql",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql"},"#"),e(" GraphQL")],-1),is=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),os=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	fields: [directus_fields]
}
`)])],-1),cs=s("h5",{id:"example",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example"},"#"),e(" Example")],-1),rs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	fields {
		collection
		field
	}
}
`)])],-1),hs=s("hr",null,null,-1),ds=s("h2",{id:"list-fields-in-collection",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#list-fields-in-collection"},"#"),e(" List Fields in Collection")],-1),ps=s("p",null,"List the available fields in a given collection.",-1),us=s("h3",{id:"query-parameters-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-1"},"#"),e(" Query Parameters")],-1),_s=s("p",null,"This endpoint doesn\u2019t currently support any query parameters.",-1),fs=s("h3",{id:"returns-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-1"},"#"),e(" Returns")],-1),js=s("p",null,[e("An array of "),s("a",{href:"#the-field-object"},"field objects"),e(".")],-1),gs=s("h3",{id:"rest-api-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-1"},"#"),e(" REST API")],-1),ms=s("pre",null,[s("code",null,`GET /fields/:collection
`)],-1),ys=s("h5",{id:"example-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-1"},"#"),e(" Example")],-1),bs=s("pre",null,[s("code",null,`GET /fields/articles
`)],-1),xs=s("h3",{id:"graphql-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-1"},"#"),e(" GraphQL")],-1),qs=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Ts=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	fields_in_collection(collection:`),s("span",{class:"hljs-type"}," String"),e(`!): directus_fields
}
`)])],-1),ws=s("h5",{id:"example-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-2"},"#"),e(" Example")],-1),ks=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	fields_in_collection(collection: `),s("span",{class:"hljs-string"},'"articles"'),e(`) {
		collection
		field
	}
}
`)])],-1),vs=s("hr",null,null,-1),As=s("h2",{id:"retrieve-a-field",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#retrieve-a-field"},"#"),e(" Retrieve a Field")],-1),Es=s("p",null,"Get a single field in a given collection.",-1),Ss=s("h3",{id:"query-parameters-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-2"},"#"),e(" Query Parameters")],-1),Ps=s("p",null,"This endpoint doesn\u2019t currently support any query parameters.",-1),Rs=s("h3",{id:"returns-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-2"},"#"),e(" Returns")],-1),Qs=s("p",null,[e("A "),s("a",{href:"#the-field-object"},"field object"),e(".")],-1),Is=s("h3",{id:"rest-api-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-2"},"#"),e(" REST API")],-1),Ls=s("pre",null,[s("code",null,`GET /fields/:collection/:field
`)],-1),Fs=s("h5",{id:"example-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-3"},"#"),e(" Example")],-1),Gs=s("pre",null,[s("code",null,`GET /fields/articles/title
`)],-1),Cs=s("h3",{id:"graphql-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-2"},"#"),e(" GraphQL")],-1),Os=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Ds=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	fields_by_name(collection:`),s("span",{class:"hljs-type"}," String"),e("!, field:"),s("span",{class:"hljs-type"}," String"),e(`!): directus_fields
}
`)])],-1),Hs=s("h5",{id:"example-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-4"},"#"),e(" Example")],-1),Ms=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	fields_by_name(collection: `),s("span",{class:"hljs-string"},'"articles"'),e(", field: "),s("span",{class:"hljs-string"},'"title"'),e(`) {
		collection
		field
	}
}
`)])],-1),Bs=s("hr",null,null,-1),Ns=s("h2",{id:"create-a-field",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#create-a-field"},"#"),e(" Create a Field")],-1),Ws=s("p",null,"Create a new field in the given collection.",-1),Us=s("h3",{id:"query-parameters-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-3"},"#"),e(" Query Parameters")],-1),Vs=s("p",null,"This endpoint doesn\u2019t currently support any query parameters.",-1),zs=s("h3",{id:"request-body",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body"},"#"),e(" Request Body")],-1),Js=s("p",null,[s("code",null,"field"),e(),s("strong",null,"Required"),s("br"),e(" Field key, also used as the column name.")],-1),Ks=s("p",null,[s("code",null,"type"),e(),s("strong",null,"Required"),s("br"),e(" One of the Directus types. This in turn controls what datatype is used for the column in the database. Setting the type to "),s("code",null,"alias"),e(" prevents a column from being created in the database.")],-1),Xs=s("p",null,[s("code",null,"meta"),s("br"),e(" Any of the optional meta values in the "),s("a",{href:"#the-field-object"},"field object"),e(".")],-1),Ys=s("p",null,[s("code",null,"schema"),s("br"),e(" Any of the optional schema values in the "),s("a",{href:"#the-field-object"},"field object"),e(".")],-1),Zs=s("h3",{id:"returns-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-3"},"#"),e(" Returns")],-1),$s=s("p",null,[e("The "),s("a",{href:"#the-field-object"},"field object"),e(" for the created field.")],-1),se=s("h3",{id:"rest-api-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-3"},"#"),e(" REST API")],-1),ee=s("pre",null,[s("code",null,`POST /fields/:collection
`)],-1),te=s("h5",{id:"example-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-5"},"#"),e(" Example")],-1),ne=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// POST /fields/articles"),e(`

`),s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"field"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"title"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"type"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"string"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"meta"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"title"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"schema"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"default_value"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Hello World"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),le=s("h3",{id:"graphql-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-3"},"#"),e(" GraphQL")],-1),ae=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),ie=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	create_fields_item(collection:`),s("span",{class:"hljs-type"}," String"),e(`!, data: create_directus_fields_input!): directus_fields
}
`)])],-1),oe=s("h5",{id:"example-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-6"},"#"),e(" Example")],-1),ce=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	create_fields_item(
		collection: `),s("span",{class:"hljs-string"},'"articles"'),e(`
		data: { field: `),s("span",{class:"hljs-string"},'"title"'),e(", "),s("span",{class:"hljs-keyword"},"type"),e(": "),s("span",{class:"hljs-string"},'"string"'),e(", meta: { icon: "),s("span",{class:"hljs-string"},'"title"'),e(" }, "),s("span",{class:"hljs-keyword"},"schema"),e(": { default_value: "),s("span",{class:"hljs-string"},'"Hello World"'),e(` } }
	) {
		collection
		field
	}
}
`)])],-1),re=s("hr",null,null,-1),he=s("h2",{id:"update-a-field",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#update-a-field"},"#"),e(" Update a Field")],-1),de=s("p",null,"Updates the given field in the given collection.",-1),pe=s("h3",{id:"query-parameters-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-4"},"#"),e(" Query Parameters")],-1),ue=s("p",null,"This endpoint doesn\u2019t currently support any query parameters.",-1),_e=s("h3",{id:"request-body-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-1"},"#"),e(" Request Body")],-1),fe=s("p",null,[s("code",null,"type"),s("br"),e(" The new type for the field.")],-1),je=s("div",{class:"warning hint"},[s("div",{class:"hint-title"},"Changing Type"),s("p",null,"Types may not be compatible, and/or data might be truncated / corrupted. Please be careful when changing types of an existing field with content.")],-1),ge=s("p",null,[s("code",null,"meta"),s("br"),e(" Any of the optional meta values in the "),s("a",{href:"#the-field-object"},"field object"),e(".")],-1),me=s("p",null,[s("code",null,"schema"),s("br"),e(" Any of the optional schema values in the "),s("a",{href:"#the-field-object"},"field object"),e(".")],-1),ye=s("p",null,"Updating the field name is not supported at this time.",-1),be=s("h3",{id:"returns-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-4"},"#"),e(" Returns")],-1),xe=s("p",null,[e("The "),s("a",{href:"#the-field-object"},"field object"),e(" for the updated field.")],-1),qe=s("h3",{id:"rest-api-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-4"},"#"),e(" REST API")],-1),Te=s("pre",null,[s("code",null,`PATCH /fields/:collection/:field
`)],-1),we=s("h5",{id:"example-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-7"},"#"),e(" Example")],-1),ke=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// PATCH /fields/articles/title"),e(`

`),s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"meta"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"note"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Put the title here"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"schema"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"default_value"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Hello World!"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),ve=s("h3",{id:"graphql-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-4"},"#"),e(" GraphQL")],-1),Ae=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Ee=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	update_fields_item(collection:`),s("span",{class:"hljs-type"}," String"),e("!, field:"),s("span",{class:"hljs-type"}," String"),e(`!, data: update_directus_fields_input!): directus_fields
}
`)])],-1),Se=s("h5",{id:"example-8",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-8"},"#"),e(" Example")],-1),Pe=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	update_fields_item(
		collection: `),s("span",{class:"hljs-string"},'"articles"'),e(`
		field: `),s("span",{class:"hljs-string"},'"title"'),e(`
		data: { meta: { note: `),s("span",{class:"hljs-string"},'"Put the title here"'),e(" }, "),s("span",{class:"hljs-keyword"},"schema"),e(": { default_value: "),s("span",{class:"hljs-string"},'"Hello World!"'),e(` } }
	) {
		collection
		field
	}
}
`)])],-1),Re=s("hr",null,null,-1),Qe=s("h2",{id:"delete-a-field",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#delete-a-field"},"#"),e(" Delete a Field")],-1),Ie=s("p",null,"Deletes the given field in the given collection.",-1),Le=s("div",{class:"danger hint"},[s("div",{class:"hint-title"},"Destructive"),s("p",null,"Be aware, this will delete the column from the database, including all data in it. This action can\u2019t be undone.")],-1),Fe=s("h3",{id:"rest-api-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-5"},"#"),e(" REST API")],-1),Ge=s("pre",null,[s("code",null,`DELETE /fields/:collection/:field
`)],-1),Ce=s("h5",{id:"example-9",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-9"},"#"),e(" Example")],-1),Oe=s("pre",null,[s("code",null,`DELETE /fields/articles/title
`)],-1),De=s("h3",{id:"graphql-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-5"},"#"),e(" GraphQL")],-1),He=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Me=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	delete_fields_item(collection:`),s("span",{class:"hljs-type"}," String"),e("!, field:"),s("span",{class:"hljs-type"}," String"),e(`!): delete_field
}
`)])],-1),Be=s("h5",{id:"example-10",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-10"},"#"),e(" Example")],-1),Ne=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	delete_fields_item(collection: `),s("span",{class:"hljs-string"},'"articles"'),e(", field: "),s("span",{class:"hljs-string"},'"title"'),e(`) {
		collection
		field
	}
}
`)])],-1),Je="Fields",Ke=!1,Xe="REST and GraphQL API documentation on the Fields collection in Directus.",Ye="7 min read",Ze="page-reference",$e={__name:"fields",setup(We,{expose:o}){const n={title:"Fields",modularExtension:!1,description:"REST and GraphQL API documentation on the Fields collection in Directus.",readTime:"7 min read",pageClass:"page-reference"};return o({frontmatter:n}),(Ue,Ve)=>{const l=a("router-link"),c=a("docs-wrapper");return r(),h(c,{frontmatter:n},{default:t(()=>[s("div",d,[s("blockquote",null,[s("p",null,[e("Fields are individual pieces of content within an item. They are mapped to columns in the database. "),i(l,{to:"/docs/getting-started/glossary#fields"},{default:t(()=>[e("Learn more about Fields")]),_:1}),e(".")])]),p,u,_,f,s("p",null,[j,e(),g,m,e(" The Directus data type of the field. See "),i(l,{to:"/docs/getting-started/glossary#types"},{default:t(()=>[e("Types")]),_:1}),e(" for possible options.")]),y,b,x,q,T,w,k,v,A,E,S,P,R,Q,I,L,F,G,C,O,D,H,M,B,N,W,U,V,z,J,K,X,Y,Z,$,ss,es,ts,ns,ls,as,is,os,cs,rs,hs,ds,ps,us,_s,fs,js,gs,ms,ys,bs,xs,qs,Ts,ws,ks,vs,As,Es,Ss,Ps,Rs,Qs,Is,Ls,Fs,Gs,Cs,Os,Ds,Hs,Ms,Bs,Ns,Ws,Us,Vs,zs,Js,Ks,Xs,Ys,Zs,$s,se,ee,te,ne,le,ae,ie,oe,ce,re,he,de,pe,ue,_e,fe,je,ge,me,ye,be,xe,qe,Te,we,ke,ve,Ae,Ee,Se,Pe,Re,Qe,Ie,Le,Fe,Ge,Ce,Oe,De,He,Me,Be,Ne])]),_:1})}}};export{$e as default,Xe as description,Ke as modularExtension,Ze as pageClass,Ye as readTime,Je as title};
