import{a as l,o as c,e as h,y as n,u as t,q as e,z as s}from"./runtime-core.esm-bundler.22ec0346.js";const p={class:"markdown-body"},d=t("h2",{id:"extension-entrypoints",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#extension-entrypoints"},"#"),e(" Extension Entrypoints")],-1),u=t("p",null,[e("Your operation has two entrypoints. The App entrypoint is the "),t("code",null,"app"),e(" file and the API entrypoint is the "),t("code",null,"api"),e(" file inside the "),t("code",null,"src/"),e(" folder of your extension package.")],-1),_=t("h3",{id:"app-entrypoint",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#app-entrypoint"},"#"),e(" App Entrypoint")],-1),f=t("p",null,"The App entrypoint exports a configuration object with options to configure the appearance of your operation. When loading your operation, this object is imported by the Directus App host.",-1),b=t("p",null,"Example of an entrypoint:",-1),g=t("pre",null,[t("code",{class:"language-js"},[t("span",{class:"hljs-keyword"},"export"),e(),t("span",{class:"hljs-keyword"},"default"),e(` {
	`),t("span",{class:"hljs-attr"},"id"),e(": "),t("span",{class:"hljs-string"},"'custom'"),e(`,
	`),t("span",{class:"hljs-attr"},"name"),e(": "),t("span",{class:"hljs-string"},"'Custom'"),e(`,
	`),t("span",{class:"hljs-attr"},"icon"),e(": "),t("span",{class:"hljs-string"},"'box'"),e(`,
	`),t("span",{class:"hljs-attr"},"description"),e(": "),t("span",{class:"hljs-string"},"'This is my custom operation!'"),e(`,
	`),t("span",{class:"hljs-attr"},"overview"),e(": "),t("span",{class:"hljs-function"},[e("("),t("span",{class:"hljs-params"},"{ text }"),e(") =>")]),e(` [
		{
			`),t("span",{class:"hljs-attr"},"label"),e(": "),t("span",{class:"hljs-string"},"'Text'"),e(`,
			`),t("span",{class:"hljs-attr"},"text"),e(`: text,
		},
	],
	`),t("span",{class:"hljs-attr"},"options"),e(`: [
		{
			`),t("span",{class:"hljs-attr"},"field"),e(": "),t("span",{class:"hljs-string"},"'text'"),e(`,
			`),t("span",{class:"hljs-attr"},"name"),e(": "),t("span",{class:"hljs-string"},"'Text'"),e(`,
			`),t("span",{class:"hljs-attr"},"type"),e(": "),t("span",{class:"hljs-string"},"'string'"),e(`,
			`),t("span",{class:"hljs-attr"},"meta"),e(`: {
				`),t("span",{class:"hljs-attr"},"width"),e(": "),t("span",{class:"hljs-string"},"'full'"),e(`,
				`),t("span",{class:"hljs-attr"},"interface"),e(": "),t("span",{class:"hljs-string"},"'input'"),e(`,
			},
		},
	],
};
`)])],-1),j=t("h4",{id:"available-options",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#available-options"},"#"),e(" Available Options")],-1),m=t("li",null,[t("code",null,"id"),e(" \u2014 The unique key for this operation. It is good practice to scope proprietary operations with an author prefix.")],-1),y=t("li",null,[t("code",null,"name"),e(" \u2014 The human-readable name for this operation.")],-1),x=t("code",null,"icon",-1),w=t("li",null,[t("code",null,"description"),e(" \u2014 A short description (<80 characters) of this operation shown in the App.")],-1),v=t("li",null,[t("code",null,"overview"),e(" \u2014 An overview that will be shown on the operation\u2019s tile. Can be either a function that receives the options of the operation and returns an array of objects containing "),t("code",null,"label"),e(" and "),t("code",null,"text"),e(" or a dedicated Vue component.")],-1),A=t("li",null,[t("code",null,"options"),e(" \u2014 The options of your operation. Can be either an options object or a dedicated Vue component.")],-1),T=t("h3",{id:"api-entrypoint",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#api-entrypoint"},"#"),e(" API Entrypoint")],-1),k=t("p",null,"The API entrypoint exports a configuration object with options to configure the behavior of your operation. When loading your operation, this object is imported by the Directus API host.",-1),I=t("p",null,"Example of an entrypoint:",-1),E=t("pre",null,[t("code",{class:"language-js"},[t("span",{class:"hljs-keyword"},"export"),e(),t("span",{class:"hljs-keyword"},"default"),e(` {
	`),t("span",{class:"hljs-attr"},"id"),e(": "),t("span",{class:"hljs-string"},"'custom'"),e(`,
	`),t("span",{class:"hljs-attr"},"handler"),e(": "),t("span",{class:"hljs-function"},[e("("),t("span",{class:"hljs-params"},"{ text }"),e(") =>")]),e(` {
		`),t("span",{class:"hljs-variable language_"},"console"),e("."),t("span",{class:"hljs-title function_"},"log"),e(`(text);
	},
};
`)])],-1),P=t("h4",{id:"available-options-1",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#available-options-1"},"#"),e(" Available Options")],-1),C=t("ul",null,[t("li",null,[t("code",null,"id"),e(" \u2014 The unique key for this operation. It is good practice to scope proprietary operations with an author prefix.")]),t("li",null,[t("code",null,"handler"),e(" \u2014 The operations\u2019s handler function.")])],-1),O=t("div",{class:"warning hint"},[t("div",{class:"hint-title"},"Extension Id"),t("p",null,"The extension id needs to be identical for both entrypoints in order for Directus to recognize them as part of the same extension.")],-1),V=t("h2",{id:"handler-function",tabindex:"-1"},[t("a",{class:"header-anchor",href:"#handler-function"},"#"),e(" Handler Function")],-1),q=t("code",null,"resolve",-1),D=t("code",null,"reject",-1),B=t("p",null,[e("The handler function receives the two parameters "),t("code",null,"options"),e(" and "),t("code",null,"context"),e(". "),t("code",null,"options"),e(" is an object with the operation\u2019s options as properties and their respective already interpolated values. "),t("code",null,"context"),e(" is an object with the following properties:")],-1),N=t("ul",null,[t("li",null,[t("code",null,"services"),e(" \u2014 All API internal services.")]),t("li",null,[t("code",null,"exceptions"),e(" \u2014 API exception objects that can be used to throw \u201Cproper\u201D errors.")]),t("li",null,[t("code",null,"database"),e(" \u2014 Knex instance that is connected to the current database.")]),t("li",null,[t("code",null,"getSchema"),e(" \u2014 Async function that reads the full available schema for use in services")]),t("li",null,[t("code",null,"env"),e(" \u2014 Parsed environment variables.")]),t("li",null,[t("code",null,"logger"),e(" \u2014 "),t("a",{href:"https://github.com/pinojs/pino",target:"_blank",rel:"noopener noreferrer"},"Pino"),e(" instance.")]),t("li",null,[t("code",null,"data"),e(" \u2014 Object containing the raw data returned by the previous operations.")]),t("li",null,[t("code",null,"accountability"),e(" \u2014 Information about the current user received by the trigger.")])],-1),K="Custom Operations",L=!0,S={__name:"operations",setup(z,{expose:i}){const a={title:"Custom Operations",modularExtension:!0};return i({frontmatter:a}),(W,F)=>{const o=l("router-link"),r=l("docs-wrapper");return c(),h(r,{frontmatter:a},{default:n(()=>[t("div",p,[t("blockquote",null,[t("p",null,[e("Custom Operations allow you to create new types of steps for flows. "),s(o,{to:"/docs/getting-started/glossary#operations"},{default:n(()=>[e("Learn more about Operations")]),_:1}),e(".")])]),d,u,_,f,b,g,j,t("ul",null,[m,y,t("li",null,[x,e(" \u2014 An icon name from the "),s(o,{to:"/docs/getting-started/glossary#material-icons"},{default:n(()=>[e("material icon set")]),_:1}),e(", or the extended list of Directus custom icons.")]),w,v,A]),T,k,I,E,P,C,O,V,t("p",null,[e("The handler function defined inside the API endpoint will be called whenever the flow the operation is connected to is executed. To trigger the operation connected to the "),q,e(" anchor, the handler function has to return a value. To trigger the operation connected to the "),D,e(" anchor, the handler function has to throw with a value. This value will then be added to the "),s(o,{to:"/docs/configuration/flows#the-data-chain"},{default:n(()=>[e("data chain")]),_:1}),e(".")]),B,N])]),_:1})}}};export{S as default,L as modularExtension,K as title};
