import{a as r,o as h,e as i,y as a,u as s,q as e,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},p=s("hr",null,null,-1),u=s("h2",{id:"the-role-object",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#the-role-object"},"#"),e(" The Role Object")],-1),_=s("p",null,[s("code",null,"id"),e(),s("strong",null,"uuid"),s("br"),e(" Primary key of the role.")],-1),j=s("p",null,[s("code",null,"name"),e(),s("strong",null,"string"),s("br"),e(" Name of the role.")],-1),m=s("p",null,[s("code",null,"icon"),e(),s("strong",null,"string"),s("br"),e(" Icon for the role. Displayed in the Admin App.")],-1),f=s("p",null,[s("code",null,"description"),e(),s("strong",null,"string"),s("br"),e(" Description for the role. Displayed in the Admin App.")],-1),g=s("p",null,[s("code",null,"ip_access"),e(),s("strong",null,"csv"),s("br"),e(" A CSV of IP addresses that have access to this role. Allows you to configure an allowlist of IP addresses.")],-1),b=s("p",null,[s("code",null,"enforce_tfa"),e(),s("strong",null,"boolean"),s("br"),e(" Whether or not Two-Factor Authentication is required for users in this role.")],-1),y=s("p",null,[s("code",null,"admin_access"),e(),s("strong",null,"boolean"),s("br"),e(" If this role is considered an admin role. This means that users in this role have full permissions to everything.")],-1),x=s("p",null,[s("code",null,"app_access"),e(),s("strong",null,"boolean"),s("br"),e(" Whether or not users in this role have access to use the Admin App.")],-1),q=s("code",null,"users",-1),R=s("strong",null,"one-to-many",-1),E=s("br",null,null,-1),k=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"id"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"653925a9-970e-487a-bfc0-ab6c96affcdc"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"name"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Admin"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"supervised_user_circle"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"description"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"ip_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"enforce_tfa"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"admin_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"app_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"users"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"["),s("span",{class:"hljs-string"},'"0bc7b36a-9ba9-4ce0-83f0-0a526f354e07"'),s("span",{class:"hljs-punctuation"},"]"),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),w=s("hr",null,null,-1),T=s("h2",{id:"list-roles",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#list-roles"},"#"),e(" List Roles")],-1),P=s("p",null,"List all roles that exist in Directus.",-1),A=s("h3",{id:"query-parameters",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters"},"#"),e(" Query Parameters")],-1),S=s("h3",{id:"returns",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns"},"#"),e(" Returns")],-1),I=s("a",{href:"#the-role-object"},"role objects",-1),D=s("h3",{id:"rest-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api"},"#"),e(" REST API")],-1),L=s("pre",null,[s("code",null,`GET /roles
SEARCH /roles
`)],-1),Q=s("h3",{id:"graphql",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql"},"#"),e(" GraphQL")],-1),C=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),v=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	roles: [directus_roles]
}
`)])],-1),O=s("h5",{id:"example",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example"},"#"),e(" Example")],-1),G=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	roles {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),M=s("hr",null,null,-1),B=s("h2",{id:"retrieve-a-role",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#retrieve-a-role"},"#"),e(" Retrieve a Role")],-1),H=s("p",null,"List an existing role by primary key.",-1),U=s("h3",{id:"query-parameters-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-1"},"#"),e(" Query Parameters")],-1),N=s("h3",{id:"returns-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-1"},"#"),e(" Returns")],-1),V=s("p",null,[e("Returns the requested "),s("a",{href:"#the-role-object"},"role object"),e(".")],-1),z=s("h3",{id:"rest-api-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-1"},"#"),e(" REST API")],-1),W=s("pre",null,[s("code",null,`GET /roles/:id
`)],-1),F=s("h5",{id:"example-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-1"},"#"),e(" Example")],-1),J=s("pre",null,[s("code",null,`GET /roles/b4cb3b64-8580-4ad9-a099-eade6da24302
`)],-1),K=s("h3",{id:"graphql-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-1"},"#"),e(" GraphQL")],-1),X=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Y=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Query"),e(` {
	roles_by_id(id:`),s("span",{class:"hljs-literal"}," ID"),e(`!): directus_roles
}
`)])],-1),Z=s("h5",{id:"example-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-2"},"#"),e(" Example")],-1),$=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"query"),e(` {
	roles_by_id(id: `),s("span",{class:"hljs-number"},"2"),e(`) {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),ss=s("hr",null,null,-1),es=s("h2",{id:"create-a-role",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#create-a-role"},"#"),e(" Create a Role")],-1),as=s("p",null,"Create a new role.",-1),ts=s("h3",{id:"query-parameters-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-2"},"#"),e(" Query Parameters")],-1),ns=s("h3",{id:"request-body",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body"},"#"),e(" Request Body")],-1),ls=s("p",null,[e("A partial "),s("a",{href:"#the-role-object"},"role object"),e(".")],-1),rs=s("h3",{id:"returns-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-2"},"#"),e(" Returns")],-1),os=s("p",null,[e("Returns the "),s("a",{href:"#the-role-object"},"role object"),e(" for the created role.")],-1),cs=s("h3",{id:"rest-api-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-2"},"#"),e(" REST API")],-1),hs=s("pre",null,[s("code",null,`POST /roles
`)],-1),is=s("h5",{id:"example-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-3"},"#"),e(" Example")],-1),ds=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// POST /roles"),e(`

`),s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"name"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Interns"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"verified_user"'),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"description"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"admin_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"app_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),ps=s("h3",{id:"graphql-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-2"},"#"),e(" GraphQL")],-1),us=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),_s=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	create_roles_item(data: create_directus_roles_input!): directus_roles
}
`)])],-1),js=s("h5",{id:"example-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-4"},"#"),e(" Example")],-1),ms=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	create_roles_item(
		data: { name: `),s("span",{class:"hljs-string"},'"Interns"'),e(", icon: "),s("span",{class:"hljs-string"},'"verified_user"'),e(", description: "),s("span",{class:"hljs-literal"},"null"),e(", admin_access: "),s("span",{class:"hljs-literal"},"false"),e(", app_access: "),s("span",{class:"hljs-literal"},"true"),e(` }
	) {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),fs=s("hr",null,null,-1),gs=s("h2",{id:"create-multiple-roles",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#create-multiple-roles"},"#"),e(" Create Multiple Roles")],-1),bs=s("p",null,"Create multiple new roles.",-1),ys=s("h3",{id:"query-parameters-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-3"},"#"),e(" Query Parameters")],-1),xs=s("h3",{id:"request-body-1",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-1"},"#"),e(" Request Body")],-1),qs=s("p",null,[e("An array of partial "),s("a",{href:"#the-role-object"},"role objects"),e(".")],-1),Rs=s("h3",{id:"returns-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-3"},"#"),e(" Returns")],-1),Es=s("p",null,[e("Returns the "),s("a",{href:"#the-role-object"},"role objects"),e(" for the created roles.")],-1),ks=s("h3",{id:"rest-api-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-3"},"#"),e(" REST API")],-1),ws=s("pre",null,[s("code",null,`POST /roles
`)],-1),Ts=s("h5",{id:"example-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-5"},"#"),e(" Example")],-1),Ps=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// POST /roles"),e(`

`),s("span",{class:"hljs-punctuation"},"["),e(`
	`),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"name"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Interns"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"verified_user"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"description"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"admin_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"app_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"true")]),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"name"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"Customers"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"person"'),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"description"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"null")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"admin_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),s("span",{class:"hljs-punctuation"},","),e(`
		`),s("span",{class:"hljs-attr"},'"app_access"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-literal"},[s("span",{class:"hljs-keyword"},"false")]),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),e(`
`),s("span",{class:"hljs-punctuation"},"]"),e(`
`)])],-1),As=s("h3",{id:"graphql-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-3"},"#"),e(" GraphQL")],-1),Ss=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Is=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	create_roles_items(data: [create_directus_roles_input!]!): [directus_roles]
}
`)])],-1),Ds=s("h5",{id:"example-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-6"},"#"),e(" Example")],-1),Ls=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	create_roles_items(
		data: [
			{ name: `),s("span",{class:"hljs-string"},'"Interns"'),e(", icon: "),s("span",{class:"hljs-string"},'"verified_user"'),e(", description: "),s("span",{class:"hljs-literal"},"null"),e(", admin_access: "),s("span",{class:"hljs-literal"},"false"),e(", app_access: "),s("span",{class:"hljs-literal"},"true"),e(` }
			{ name: `),s("span",{class:"hljs-string"},'"Customers"'),e(", icon: "),s("span",{class:"hljs-string"},'"person"'),e(", description: "),s("span",{class:"hljs-literal"},"null"),e(", admin_access: "),s("span",{class:"hljs-literal"},"false"),e(", app_access: "),s("span",{class:"hljs-literal"},"false"),e(` }
		]
	) {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),Qs=s("hr",null,null,-1),Cs=s("h2",{id:"update-a-role",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#update-a-role"},"#"),e(" Update a Role")],-1),vs=s("p",null,"Update an existing role.",-1),Os=s("h3",{id:"query-parameters-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-4"},"#"),e(" Query Parameters")],-1),Gs=s("h3",{id:"request-body-2",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-2"},"#"),e(" Request Body")],-1),Ms=s("p",null,[e("A partial "),s("a",{href:"#the-role-object"},"role object"),e(".")],-1),Bs=s("h3",{id:"returns-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-4"},"#"),e(" Returns")],-1),Hs=s("p",null,[e("Returns the "),s("a",{href:"#the-role-object"},"role object"),e(" for the updated role.")],-1),Us=s("h3",{id:"rest-api-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-4"},"#"),e(" REST API")],-1),Ns=s("pre",null,[s("code",null,`PATCH /roles/:id
`)],-1),Vs=s("h5",{id:"example-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-7"},"#"),e(" Example")],-1),zs=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// PATCH /roles/c86c2761-65d3-43c3-897f-6f74ad6a5bd7"),e(`

`),s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"attractions"'),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),Ws=s("h3",{id:"graphql-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-4"},"#"),e(" GraphQL")],-1),Fs=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Js=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	update_roles_item(id:`),s("span",{class:"hljs-literal"}," ID"),e(`!, data: update_directus_roles_input): directus_roles
}
`)])],-1),Ks=s("h5",{id:"example-8",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-8"},"#"),e(" Example")],-1),Xs=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	update_roles_item(id: `),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),e(", data: { icon: "),s("span",{class:"hljs-string"},'"attractions"'),e(` }) {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),Ys=s("hr",null,null,-1),Zs=s("h2",{id:"update-multiple-roles",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#update-multiple-roles"},"#"),e(" Update Multiple Roles")],-1),$s=s("p",null,"Update multiple existing roles.",-1),se=s("h3",{id:"query-parameters-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#query-parameters-5"},"#"),e(" Query Parameters")],-1),ee=s("h3",{id:"request-body-3",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-3"},"#"),e(" Request Body")],-1),ae=s("p",null,[s("code",null,"keys"),e(),s("strong",null,"Required"),s("br"),e(" Array of primary keys of the roles you\u2019d like to update.")],-1),te=s("p",null,[s("code",null,"data"),e(),s("strong",null,"Required"),s("br"),e(" Any of "),s("a",{href:"#the-role-object"},"the role object"),e("\u2019s properties.")],-1),ne=s("h3",{id:"returns-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-5"},"#"),e(" Returns")],-1),le=s("p",null,[e("Returns the "),s("a",{href:"#the-role-object"},"role objects"),e(" for the updated roles.")],-1),re=s("h3",{id:"rest-api-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-5"},"#"),e(" REST API")],-1),oe=s("pre",null,[s("code",null,`PATCH /roles
`)],-1),ce=s("h5",{id:"example-9",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-9"},"#"),e(" Example")],-1),he=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// PATCH /roles"),e(`

`),s("span",{class:"hljs-punctuation"},"{"),e(`
	`),s("span",{class:"hljs-attr"},'"keys"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"["),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),s("span",{class:"hljs-punctuation"},","),e(),s("span",{class:"hljs-string"},'"6fc3d5d3-a37b-4da8-a2f4-ed62ad5abe03"'),s("span",{class:"hljs-punctuation"},"]"),s("span",{class:"hljs-punctuation"},","),e(`
	`),s("span",{class:"hljs-attr"},'"data"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-punctuation"},"{"),e(`
		`),s("span",{class:"hljs-attr"},'"icon"'),s("span",{class:"hljs-punctuation"},":"),e(),s("span",{class:"hljs-string"},'"attractions"'),e(`
	`),s("span",{class:"hljs-punctuation"},"}"),e(`
`),s("span",{class:"hljs-punctuation"},"}"),e(`
`)])],-1),ie=s("h3",{id:"graphql-5",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-5"},"#"),e(" GraphQL")],-1),de=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),pe=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	update_roles_items(ids: `),s("span",{class:"hljs-literal"},"[ID"),e(`!]!, data: update_directus_roles_input): [directus_roles]
}
`)])],-1),ue=s("h5",{id:"example-10",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-10"},"#"),e(" Example")],-1),_e=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	update_roles_items(
		ids: [`),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),e(", "),s("span",{class:"hljs-string"},'"6fc3d5d3-a37b-4da8-a2f4-ed62ad5abe03"'),e(`]
		data: { icon: `),s("span",{class:"hljs-string"},'"attractions"'),e(` }
	) {
		id
		name
		users {
			email
		}
	}
}
`)])],-1),je=s("hr",null,null,-1),me=s("h2",{id:"delete-a-role",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#delete-a-role"},"#"),e(" Delete a Role")],-1),fe=s("p",null,"Delete an existing role.",-1),ge=s("h3",{id:"returns-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-6"},"#"),e(" Returns")],-1),be=s("p",null,"Empty body.",-1),ye=s("h3",{id:"rest-api-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-6"},"#"),e(" REST API")],-1),xe=s("pre",null,[s("code",null,`DELETE /roles/:id
`)],-1),qe=s("h5",{id:"example-11",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-11"},"#"),e(" Example")],-1),Re=s("pre",null,[s("code",null,`DELETE /roles/c86c2761-65d3-43c3-897f-6f74ad6a5bd7
`)],-1),Ee=s("h3",{id:"graphql-6",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-6"},"#"),e(" GraphQL")],-1),ke=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),we=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	delete_roles_item(id:`),s("span",{class:"hljs-literal"}," ID"),e(`!): delete_one
}
`)])],-1),Te=s("h5",{id:"example-12",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-12"},"#"),e(" Example")],-1),Pe=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	delete_roles_item(id: `),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),e(`) {
		id
	}
}
`)])],-1),Ae=s("hr",null,null,-1),Se=s("h2",{id:"delete-multiple-roles",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#delete-multiple-roles"},"#"),e(" Delete Multiple Roles")],-1),Ie=s("p",null,"Delete multiple existing roles.",-1),De=s("h3",{id:"request-body-4",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#request-body-4"},"#"),e(" Request Body")],-1),Le=s("p",null,"An array of role primary keys",-1),Qe=s("h3",{id:"returns-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#returns-7"},"#"),e(" Returns")],-1),Ce=s("p",null,"Empty body.",-1),ve=s("h3",{id:"rest-api-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#rest-api-7"},"#"),e(" REST API")],-1),Oe=s("pre",null,[s("code",null,`DELETE /roles
`)],-1),Ge=s("h5",{id:"example-13",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-13"},"#"),e(" Example")],-1),Me=s("pre",null,[s("code",{class:"language-json"},[s("span",{class:"hljs-comment"},"// DELETE /roles"),e(`
`),s("span",{class:"hljs-punctuation"},"["),s("span",{class:"hljs-string"},'"653925a9-970e-487a-bfc0-ab6c96affcdc"'),s("span",{class:"hljs-punctuation"},","),e(),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),s("span",{class:"hljs-punctuation"},"]"),e(`
`)])],-1),Be=s("h3",{id:"graphql-7",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#graphql-7"},"#"),e(" GraphQL")],-1),He=s("pre",null,[s("code",null,`POST /graphql/system
`)],-1),Ue=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"type"),s("span",{class:"hljs-type"}," Mutation"),e(` {
	delete_roles_items(ids: `),s("span",{class:"hljs-literal"},"[ID"),e(`!]!): delete_many
}
`)])],-1),Ne=s("h5",{id:"example-14",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#example-14"},"#"),e(" Example")],-1),Ve=s("pre",null,[s("code",{class:"language-graphql"},[s("span",{class:"hljs-keyword"},"mutation"),e(` {
	delete_roles_items(ids: [`),s("span",{class:"hljs-string"},'"653925a9-970e-487a-bfc0-ab6c96affcdc"'),e(", "),s("span",{class:"hljs-string"},'"c86c2761-65d3-43c3-897f-6f74ad6a5bd7"'),e(`]) {
		ids
	}
}
`)])],-1),ze=s("hr",null,null,-1),Xe="Roles",Ye=!1,Ze="REST and GraphQL API documentation on the Roles collection in Directus.",$e="5 min read",sa="page-reference",ea={__name:"roles",setup(We,{expose:o}){const l={title:"Roles",modularExtension:!1,description:"REST and GraphQL API documentation on the Roles collection in Directus.",readTime:"5 min read",pageClass:"page-reference"};return o({frontmatter:l}),(Fe,Je)=>{const t=r("router-link"),c=r("docs-wrapper");return h(),i(c,{frontmatter:l},{default:a(()=>[s("div",d,[s("blockquote",null,[s("p",null,[e("Roles define a specific set of access permissions, and are the primary organizational structure for Users within the platform. "),n(t,{to:"/docs/getting-started/glossary#roles"},{default:a(()=>[e("Learn more about Roles")]),_:1}),e(".")])]),p,u,_,j,m,f,g,b,y,x,s("p",null,[q,e(),R,E,e(" The users in this role. One-to-many to "),n(t,{to:"/docs/reference/system/users"},{default:a(()=>[e("users")]),_:1}),e(".")]),k,w,T,P,A,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),S,s("p",null,[e("An array of up to "),n(t,{to:"/docs/reference/query#limit"},{default:a(()=>[e("limit")]),_:1}),e(),I,e(". If no items are available, data will be an empty array.")]),D,L,s("p",null,[n(t,{to:"/docs/reference/introduction#search-http-method"},{default:a(()=>[e("Learn more about SEARCH ->")]),_:1})]),Q,C,v,O,G,M,B,H,U,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),N,V,z,W,F,J,K,X,Y,Z,$,ss,es,as,ts,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),ns,ls,rs,os,cs,hs,is,ds,ps,us,_s,js,ms,fs,gs,bs,ys,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),xs,qs,Rs,Es,ks,ws,Ts,Ps,As,Ss,Is,Ds,Ls,Qs,Cs,vs,Os,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),Gs,Ms,Bs,Hs,Us,Ns,Vs,zs,Ws,Fs,Js,Ks,Xs,Ys,Zs,$s,se,s("p",null,[e("Supports all "),n(t,{to:"/docs/reference/query"},{default:a(()=>[e("global query parameters")]),_:1}),e(".")]),ee,ae,te,ne,le,re,oe,ce,he,ie,de,pe,ue,_e,je,me,fe,ge,be,ye,xe,qe,Re,Ee,ke,we,Te,Pe,Ae,Se,Ie,De,Le,Qe,Ce,ve,Oe,Ge,Me,Be,He,Ue,Ne,Ve,ze])]),_:1})}}};export{ea as default,Ze as description,Ye as modularExtension,sa as pageClass,$e as readTime,Xe as title};
