import{a as o,o as n,e as i,y as c,u as e,q as t}from"./runtime-core.esm-bundler.22ec0346.js";const l=e("div",{class:"markdown-body"},[e("p",null,[e("strong",null,"Directus is a wrapper for both your database and file asset storage system.")]),e("p",null,"At first glance, it may be tempting to think of Directus as an app-centric platform. But that\u2019s not the case. The app is just a GUI powered by the API, which allows developers, business users, and data analysts equal access to data and asset storage, all in one place."),e("p",null,"Here\u2019s how the platform architecture breaks down."),e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/getting-started/architecture/architecture-20220512/directus-architecture-20220512A.webp",alt:"Directus Architecture Graphic"})]),e("p",null,[t("Directus is plug-and-play. Once linked, it does\u2019t "),e("em",null,"own"),t(" your data or file assets, but it does create about 10-20 data tables needed for platform operation. These tables do not intermingle with the rest of your data, so you can remove Directus without a trace. You also have the freedom to access the database with raw SQL queries and access your file assets with CLI commands.")]),e("p",null,"At the lowest layer, the platform introspects the database and abstracts away specific SQL details- so no matter what SQL vendor you choose, the platform works seamlessly. Similarly, Directus syncs with your configured file storage service, providing control over your file assets."),e("p",null,[t("The next layer contains logic to access, transmit, query, and transform data, including event triggers, webhooks, data query operations, and file transformations "),e("em",null,"(like image cropping)"),t(". After that, data and assets get cached for efficient user access.")]),e("p",null,"Directus provides secure user access methods. Choose access token format and configure authentication as desired. You can set SSO and allow login through Google, Facebook, etc."),e("p",null,"Finally, a complete set of REST and GraphQL endpoints are generated dynamically, based on your data model as well as your configured roles and their associated access permissions."),e("p",null,[t("The Directus SDK is "),e("a",{href:"https://www.npmjs.com/package/directus",target:"_blank",rel:"noopener noreferrer"},"available via NPM"),t(". You also have access to two Command-Line Interfaces (CLI). One enables server-side actions relating to your on-prem instance, like migrating the database or resetting a user. The other allows you to interact with a Directus instance as you would with an SDK.")]),e("p",null,[t("Directus is 100% open-source, modular, and extensible, ensuring you will never hit a hard feature ceiling within the platform. Built entirely in crispy clean Typescript, mostly on Node.js and Vue.js, you have the power to add or modify "),e("em",null,"any feature"),t(" with your own custom extensions.")])],-1),m="Architecture",f=!1,w="A breakdown of the Directus platform architecture.",y="2 min read",g={__name:"architecture",setup(u,{expose:s}){const a={title:"Architecture",modularExtension:!1,description:"A breakdown of the Directus platform architecture.",readTime:"2 min read"};return s({frontmatter:a}),(d,h)=>{const r=o("docs-wrapper");return n(),i(r,{frontmatter:a},{default:c(()=>[l]),_:1})}}};export{g as default,w as description,f as modularExtension,y as readTime,m as title};
