import{a as s,o as c,e as d,y as t,u as e,q as o,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("p",null,"While there are many different ways to run Directus on AWS, from single EC2 instances to a full ELB load-balanced configuration, we like the following combination of services:",-1),p=e("ul",null,[e("li",null,[o("Elastic Beanstalk (EB) "),e("ul",null,[e("li",null,"Elastic Load Balancer (ELB)"),e("li",null,"Elastic Compute Cloud (EC2)")])]),e("li",null,"CodeDeploy"),e("li",null,"Simple Storage Service (S3)"),e("li",null,"Relational Database Service (RDS) (Aurora)"),e("li",null,"CloudFront"),e("li",null,"Route 53")],-1),f=e("h2",{id:"elastic-beanstalk",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#elastic-beanstalk"},"#"),o(" Elastic Beanstalk")],-1),m=e("p",null,"Will run Directus in an autoscaling environment with a load balancer. Makes sure the instances stay alive, and will replace individual instances in case of unexpected crashes.",-1),_=e("p",null,[o("See "),e("a",{href:"https://docs.aws.amazon.com/elasticbeanstalk/latest/dg/create_deploy_nodejs.html",target:"_blank",rel:"noopener noreferrer"},"Deploying Node.js applications to Elastic Beanstalk"),o(" for more information.")],-1),b=e("h2",{id:"codedeploy",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#codedeploy"},"#"),o(" CodeDeploy")],-1),g=e("p",null,"Allows you to automatically deploy updates to your Directus instance or extensions to Elastic Beanstalk.",-1),y=e("p",null,[o("See "),e("a",{href:"https://aws.amazon.com/blogs/devops/automatically-deploy-from-github-using-aws-codedeploy",target:"_blank",rel:"noopener noreferrer"},"Automatically Deploy from GitHub Using AWS CodeDeploy"),o(" for more information.")],-1),w=e("h2",{id:"simple-storage-service-(s3)",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#simple-storage-service-(s3)"},"#"),o(" Simple Storage Service (S3)")],-1),k=e("p",null,"Ideal place to store files uploaded to Directus. Your bucket doesn\u2019t have to be publicly accessible to the web; Directus will stream files from and to the bucket in its /asset endpoint.",-1),v=e("p",null,[o("See "),e("a",{href:"https://docs.aws.amazon.com/AmazonS3/latest/gsg/CreatingABucket.html",target:"_blank",rel:"noopener noreferrer"},"Creating a bucket"),o(" for more information.")],-1),S=e("h2",{id:"relational-database-service-(rds)-(aurora)",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#relational-database-service-(rds)-(aurora)"},"#"),o(" Relational Database Service (RDS) (Aurora)")],-1),D=e("p",null,"While you can technically use any of the SQL based databases offered in AWS, we like to use Aurora. It\u2019s auto-scaling and use-based costs have worked out pretty well for us in the past.",-1),C=e("h2",{id:"cloudfront",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#cloudfront"},"#"),o(" CloudFront")],-1),A=e("p",null,"While it\u2019s not a technical requirement, it\u2019s not a bad idea to configure a CloudFront instance in front of your EB environment. This protects you from DDoS attacks and allows you to cache repeated calls to assets in its CDN.",-1),E=e("p",null,[o("See "),e("a",{href:"https://docs.aws.amazon.com/elasticbeanstalk/latest/dg/AWSHowTo.cloudfront.html",target:"_blank",rel:"noopener noreferrer"},"Using Elastic Beanstalk with Amazon CloudFront"),o(" for more information.")],-1),B=e("h2",{id:"route-53",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#route-53"},"#"),o(" Route 53")],-1),x=e("p",null,"The last piece of this puzzle is to assign a domain name to your CloudFront instance. You can use Route 53 for this purpose.",-1),W=e("p",null,[o("See "),e("a",{href:"https://docs.aws.amazon.com/Route53/latest/DeveloperGuide/routing-to-cloudfront-distribution.html",target:"_blank",rel:"noopener noreferrer"},"Routing traffic to an Amazon CloudFront web distribution by using your domain name"),o(" for more information.")],-1),H="AWS",N=!1,G="How to host Directus on AWS.",L="2 min read",V={__name:"aws",setup(z,{expose:r}){const a={title:"AWS",modularExtension:!1,description:"How to host Directus on AWS.",readTime:"2 min read"};return r({frontmatter:a}),(R,F)=>{const n=s("router-link"),i=s("docs-wrapper");return c(),d(i,{frontmatter:a},{default:t(()=>[e("div",u,[h,p,f,m,e("p",null,[o("We recommend setting up a repo in GitHub (or another Git provider) and configuring it using "),l(n,{to:"/docs/self-hosted/installation/manual"},{default:t(()=>[o("our manual installation flow")]),_:1}),o(". This allows you to later hook up the repo to your Elastic Beanstalk instance through CodeDeploy.")]),_,e("p",null,[o("Directus\u2019 configuration is all set through environment variables. For a full overview of all available environment variables, see "),l(n,{to:"/docs/self-hosted/config-options"},{default:t(()=>[o("Environment Variables")]),_:1})]),b,g,y,w,k,v,S,D,C,A,E,B,x,W])]),_:1})}}};export{V as default,G as description,N as modularExtension,L as readTime,H as title};
