import{a as n,o as d,e as c,y as o,u as e,q as t,z as i}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"Filters allow you to conditionally select Items from a Collection. Use-cases include customizing Item search results, restricting Item access permissions for specific Users or Roles, building dashboard analytics with the Insights module, and more.")],-1),p=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/filters-20220303A.webp",alt:"Filters"})],-1),f={class:"warning hint"},m=e("div",{class:"hint-title"},"There Are Two Filters Documents",-1),_=e("h2",{id:"how-it-works",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-it-works"},"#"),t(" How it Works")],-1),y={class:"tip hint"},g=e("div",{class:"hint-title"},"Assumed Knowledge",-1),b=e("strong",null,"Field",-1),w=e("strong",null,"Value",-1),F=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"How Filters Work"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/how-filters-work-20220303A.mp4",type:"video/mp4"})],-1),v=e("ol",{start:"2"},[e("li",null,[t("Click "),e("span",{mi:"",icon:""},"filter_list"),t(" or "),e("strong",null,"\u201CAdd Filter\u201D"),t(".")]),e("li",null,"Select the Field to filter by."),e("li",null,"Select the Operator as desired."),e("li",null,"Define the Value to filter for.")],-1),C=e("p",null,[t("From here, you can set multiple Filters at once, filter by "),e("a",{href:"#filtering-by-related-collections"},"Fields in related Collections"),t(", set Values with "),e("a",{href:"#dynamic-variables"},"Dynamic Variables"),t(", as well as apply "),e("a",{href:"#and-or-groups"},"AND/OR Groups"),t(".")],-1),A={class:"tip hint"},k=e("div",{class:"hint-title"},"Operators",-1),x=e("a",{href:"#unfilterable-fields"},"Unfilterable Fields",-1),R=e("h2",{id:"and%2For-groups",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#and%2For-groups"},"#"),t(" AND/OR Groups")],-1),O=e("p",null,[e("code",null,"AND"),t(" Groups give the option to filter for Items that meet "),e("em",null,"all of several criteria"),t(". On the other hand, "),e("code",null,"OR"),t(" Groups filter for Items that meet "),e("em",null,"any one of several criteria"),t(".")],-1),I=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/and-or-groups-20220303A.webp",alt:"AND/OR Groups"})],-1),D=e("ol",null,[e("li",null,"Click \u201CAdd Filter\u201D."),e("li",null,"Click \u201CAnd/OR Group\u201D at the very top of the dropdown menu."),e("li",null,[t("Click the AND/OR text to toggle: "),e("ul",null,[e("li",null,[e("code",null,"AND"),t(" \u2013 Selects Items that meet every single criteria.")]),e("li",null,[e("code",null,"OR"),t(" \u2013 Selects Items that meet one of several criteria.")])])]),e("li",null,"Click \u201CAdd Filter\u201D again."),e("li",null,"Configure the Field, Operator, and Value as desired."),e("li",null,[t("Click and hold "),e("span",{mi:"",icon:""},"drag_indicator"),t(" to drag a Filter and nest it under an AND/OR Group.")])],-1),N=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Why do we need AND Groups?"),e("p",null,[t("Filters actually default to "),e("code",null,"AND"),t(" Group behavior automatically. However, when Filters are nested inside of an OR Group, they of course switch to "),e("code",null,"OR"),t(" Group behavior. So an AND Group is necessary in cases where you want to meet multiple conditions inside of OR Groups.")])],-1),G=e("h2",{id:"dynamic-variables",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#dynamic-variables"},"#"),t(" Dynamic Variables")],-1),T=e("p",null,"The following video shows how to filter for Blog posts written within the past 60 days.",-1),U=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"How Filters Work"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/dynamic-variables-20220307A.mp4",type:"video/mp4"})],-1),V=e("code",null,"$CURRENT_USER",-1),E=e("code",null,"$CURRENT_ROLE",-1),H=e("code",null,"$NOW",-1),S=e("code",null,"$NOW(<adjustment>)",-1),W=e("h2",{id:"filtering-by-related-collections",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#filtering-by-related-collections"},"#"),t(" Filtering by Related Collections")],-1),B=e("p",null,[t("You may need to run filters on one Collection "),e("em",null,"based on information in another related Collection"),t(". Here are a few examples of when that might happen:")],-1),z=e("ul",null,[e("li",null,[t("Book authors that also wrote screenplays (filters "),e("code",null,"authors"),t(", uses "),e("code",null,"screenplays"),t(").")]),e("li",null,[t("Products with a 5 star customer review (filters "),e("code",null,"products"),t(", uses "),e("code",null,"reviews"),t(").")]),e("li",null,[t("Accounts with active user login within the last 12 months (filters "),e("code",null,"accounts"),t(", uses "),e("code",null,"logins"),t(").")])],-1),$=e("p",null,[t("This can span across any number of relationally linked Collections. For example, you could filter for customers that bought rock songs, where the "),e("code",null,"customers"),t(" and "),e("code",null,"genres"),t(" Collections are linked by "),e("code",null,"customers"),t(" -> "),e("code",null,"invoices"),t(" -> "),e("code",null,"invoice-items"),t(" -> "),e("code",null,"tracks"),t(" -> "),e("code",null,"genres"),t(".")],-1),j=e("span",{mi:"",icon:""},"chevron_right",-1),q=e("p",null,"Here are step-by-step instructions on how to filter by Fields in other Collections:",-1),P=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"How Filters Work"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/filtering-by-related-collections-20220303A.mp4",type:"video/mp4"})],-1),L=e("ol",null,[e("li",null,"Click \u201CAdd Filter\u201D."),e("li",null,"Click the desired relational Field. This will pop down and display the related Collection Fields."),e("li",null,"Select a Field from this related Collection."),e("li",null,"Set the Operator and Value as desired.")],-1),Y=e("h2",{id:"unfilterable-fields",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#unfilterable-fields"},"#"),t(" Unfilterable Fields")],-1),K=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/filters/filters-20220303A/unfilterable-fields-20220303A.webp",alt:"Unfilterable Fields"})],-1),M=e("p",null,[t("Not all Fields can be filtered. As seen above in "),e("a",{href:"#filtering-by-related-collections"},"Filtering by Related Collections"),t(", Alias Fields cannot be filtered; they instead provide a dropdown menu to access Fields from a related Collection. Additionally, the \u201CPresentation\u201D and \u201CGroup\u201D Fields cannot be filtered at all and will not appear as an option in Filters.")],-1),J=e("h2",{id:"extensibility-options",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#extensibility-options"},"#"),t(" Extensibility Options")],-1),Q=e("p",null,"Directus Core is completely open-source, modular and extensible. Extensions allow you to expand or modify any part of Directus to fit your needs. Here are some great resources to get started down that track.",-1),X=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Accelerated Development"),e("p",null,[t("Working on an enterprise project and looking to outsource or financially sponsor the development of a Shares extension? Contact "),e("a",{href:"https://directus.io/contact",target:"_blank",rel:"noopener noreferrer"},"our team")])],-1),Z=e("h2",{id:"more-help",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#more-help"},"#"),t(" More Help")],-1),ee=e("p",null,[t("Looking for technical support for your non-enterprise project? Chat with thousands of engineers within our growing "),e("a",{href:"https://discord.com/invite/directus",target:"_blank",rel:"noopener noreferrer"},"Community on Discord")],-1),se="Filters",ne=!1,re="Filters allow you to conditionally select Items from a Collection. Use-cases include customizing Item search results restricting Item access permissions for specific Users or Roles, building dashboard analytics with the Insights module, and more.",ae="5 min read",de={__name:"filters",setup(te,{expose:r}){const s={title:"Filters",modularExtension:!1,description:"Filters allow you to conditionally select Items from a Collection. Use-cases include customizing Item search results restricting Item access permissions for specific Users or Roles, building dashboard analytics with the Insights module, and more.",readTime:"5 min read"};return r({frontmatter:s}),(oe,le)=>{const l=n("router-link"),a=n("docs-wrapper");return d(),c(a,{frontmatter:s},{default:o(()=>[e("div",u,[h,p,e("div",f,[m,e("p",null,[t("This page is a non-technical guide to using Filters. For more technical info, see "),i(l,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter-Rules")]),_:1}),t(".")])]),_,e("div",y,[g,e("p",null,[t("Filters are intuitive to use, but get quite nuanced as complexity increases. In order to use Filters effectively, you will need to understand the Field "),e("em",null,[t("(aka "),i(l,{to:"/docs/configuration/data-model"},{default:o(()=>[t("data model")]),_:1}),t(")")]),t(" being filtered as well as any relevant "),i(l,{to:"/docs/configuration/users-roles-permissions.md"},{default:o(()=>[t("Users, Roles and Permissions")]),_:1}),t(".")])]),e("p",null,[t("A basic filter is composed of 3 parts: A "),b,t(" from the Collection being Filtered, a logical "),i(l,{to:"/docs/reference/filter-rules#filter-operators"},{default:o(()=>[t("Operator")]),_:1}),t(", and some specified "),w,t(" to filter for within each Item\u2019s Field.")]),F,v,C,e("div",A,[k,e("p",null,[t("The Field type will determine the kinds of Operators that can be used on it. In fact, some Fields cannot be filtered at all (read more in "),x,t("). Once a Field is selected, the permitted operators will automatically display. An exhaustive list of Operators and what they do can be found in the more technical "),i(l,{to:"/docs/reference/filter-rules#filter-operators"},{default:o(()=>[t("Filter Rules")]),_:1}),t(" document.")])]),R,O,I,D,N,G,T,U,e("p",null,[t("The following Dynamic Variables are built into Directus to make Filtering easier: "),V,t(", "),E,t(", "),H,t(" and "),S,t(". For more information, please see the Dynamic Variables section in "),i(l,{to:"/docs/reference/filter-rules"},{default:o(()=>[t("Filter Rules")]),_:1}),t(".")]),W,B,z,$,e("p",null,[t("You will notice a "),j,t(" icon beside relational Fields. When you click on any "),i(l,{to:"/docs/getting-started/glossary#alias"},{default:o(()=>[t("Alias")]),_:1}),t(" Field, all the Fields for that associated Collection pop down. If you select one of these Fields, you can run Filters on the current Collection by Field values in a related Collection.")]),q,P,L,Y,K,M,J,Q,e("ul",null,[e("li",null,[i(l,{to:"/docs/extensions/introduction"},{default:o(()=>[t("Extensions > Introduction")]),_:1})]),e("li",null,[i(l,{to:"/docs/extensions/creating-extensions"},{default:o(()=>[t("Extensions > Creating Extensions")]),_:1})]),e("li",null,[i(l,{to:"/docs/contributing/introduction"},{default:o(()=>[t("Contributing > Introduction")]),_:1})]),e("li",null,[i(l,{to:"/docs/contributing/codebase-overview"},{default:o(()=>[t("Contributing > Codebase Overview")]),_:1})])]),X,Z,ee])]),_:1})}}};export{de as default,re as description,ne as modularExtension,ae as readTime,se as title};
