import{a as r,o as d,e as p,y as o,u as e,q as t,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const c={class:"markdown-body"},m=e("blockquote",null,[e("p",null,"The Content, User Directory, and File Library modules allow importing and exporting of multiple Items stored as files. This makes it quick and easy to handle tasks like uploading and downloading new customer information; pulling down sales data for transformation, reports, analysis, and beyond.")],-1),h={class:"tip hint"},u=e("div",{class:"hint-title"},"Before You Begin",-1),x={class:"tip hint"},f=e("div",{class:"hint-title"},"Import / Export via the API",-1),_=e("h2",{id:"import-items",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#import-items"},"#"),t(" Import Items")],-1),g=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Import Data From a File"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/imports-exports/imports-exports-20220415A/import-items-20220416A.mp4",type:"video/mp4"})],-1),y=e("p",null,"To import Items from a file, follow the steps below.",-1),w=e("ol",null,[e("li",null,[t("Navigate to the desired Module and Collection."),e("br"),t(" Note: the User Directory and File Library are each composed of just one Collection.")]),e("li",null,[t("Click "),e("strong",null,"\u201CImport / Export\u201D"),t(" in the Sidebar.")]),e("li",null,"Click into the import search box. A file browser will open."),e("li",null,[t("Select the desired file and click "),e("strong",null,"\u201Copen\u201D"),t(".")]),e("li",null,[t("Click "),e("strong",null,"\u201CStart Import\u201D"),t(" to import the Items.")])],-1),I=e("p",null,"The Items will now be in the Collection. The file itself will not be stored in the Directus Project.",-1),b=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Importing Relational Files"),e("p",null,"It is possible to import relational Field values as well. For this task, the User performing the import will need access permissions for the related Collection and a firm understanding of the relational data model.")],-1),v=e("h2",{id:"export-items",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#export-items"},"#"),t(" Export Items")],-1),F=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Export Data to a File"},[e("source",{src:`https://cdn.directus.io/docs/v9/app-guide/imports-exports/imports-exports-20220415A/export-items-20220416A.mp4
`,type:"video/mp4"})],-1),C=e("p",null,[t("When exporting Items, the "),e("a",{href:"#export-items-menu"},"Export Items Menu"),t(" provides granular control over exactly which Items and Fields are exported, how they are exported, and where they are exported. To export Items, follow the steps below.")],-1),E=e("ol",null,[e("li",null,[t("Navigate to the desired Module and Collection."),e("br"),t(" Note: the User Directory and File Library are each composed of one Collection.")]),e("li",null,[t("Click "),e("strong",null,"\u201CImport / Export\u201D"),t(" in the Sidebar.")]),e("li",null,[t("Click "),e("strong",null,"\u201CExport Items\u201D"),t(" and the "),e("a",{href:"#export-items-menu"},"Export Items Menu"),t(" will appear.")]),e("li",null,"Choose the desired format: CSV, JSON or XML."),e("li",null,[e("strong",null,"Optional:"),t(" Configure any other export details as desired.")]),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"download"),t(" to download the file.")])],-1),k=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Opening the file in Excel?"),e("p",null,"Export your file to CSV to seamlessly open in excel.")],-1),L=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Exporting to File Library"),e("p",null,"When downloading 2,500 or more Items, you will be required to download into the Directus Project\u2019s File Library. After exporting, go to the File Library to download your file locally.")],-1),T=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Exporting Relational Files"),e("p",null,"It is possible to export relational Field values. For this task, the User performing the export will need access permissions for the related Collection and a firm understanding of the relational data model.")],-1),S=e("h2",{id:"export-items-menu",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#export-items-menu"},"#"),t(" Export Items Menu")],-1),A=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:"",title:"Export Data to a File"},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/imports-exports/imports-exports-20220415A/export-items-menu-20220416A.mp4",type:"video/mp4"})],-1),D=e("p",null,"This menu provides granular control over exactly which Items and Fields are exported, how they are exported, and where they are exported.",-1),M=e("ul",null,[e("li",null,[e("strong",null,"Format"),t(" \u2014 Choose to export Items as CSV, JSON, or XML.")]),e("li",null,[e("strong",null,"Limit"),t(" \u2014 Set the maximum number of Items to be exported.")]),e("li",null,[e("strong",null,"Export Location"),t(" \u2014 Download the export file directly to your machine or to the File Library.")]),e("li",null,[e("strong",null,"Folder"),t(" \u2014 Choose the Folder to download to "),e("em",null,"(if export location is the Folder Library)"),t(".")]),e("li",null,[e("strong",null,"Sort Field"),t(" \u2014 Choose Field to sort Items by.")]),e("li",null,[e("strong",null,"Sort Direction"),t(" \u2014 Choose to sort Items in ascending or descending order.")]),e("li",null,[e("strong",null,"Full-Text Search"),t(" \u2014 Limit exported Items to ones which matched as search results.")]),e("li",null,[e("strong",null,"Filter"),t(" \u2014 Limit exported Items with a Filter.")]),e("li",null,[e("strong",null,"Fields"),t(" \u2014 Add, remove, and re-order the Item Fields that will be exported.")])],-1),N=e("h2",{id:"file-assets-and-media",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#file-assets-and-media"},"#"),t(" File Assets and Media")],-1),U=e("p",null,"Some Collections may directly or relationally include Fields referencing images, videos or other file types. It is not possible to import or export files with this utility.",-1),V=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"What does Import/Export do in the File Library?!"),e("p",null,[t("Import/Export handles Field Values associated with the file "),e("em",null,"(e.g. id, title, description, etc.)"),t(".")])],-1),j="Import / Export",W=!1,J="The Content, User Directory, and File Library modules allow importing and exporting of multiple Items stored as files.",R="4 min read",X={__name:"import-export",setup(B,{expose:n}){const s={title:"Import / Export",modularExtension:!1,description:"The Content, User Directory, and File Library modules allow importing and exporting of multiple Items stored as files.",readTime:"4 min read"};return n({frontmatter:s}),(q,O)=>{const i=r("router-link"),a=r("docs-wrapper");return d(),p(a,{frontmatter:s},{default:o(()=>[e("div",c,[m,e("div",h,[u,e("p",null,[t("To use this utility, you will need to be familiar with "),l(i,{to:"/docs/getting-started/glossary#collections"},{default:o(()=>[t("Collections")]),_:1}),t(", "),l(i,{to:"/docs/getting-started/glossary#items"},{default:o(()=>[t("Items")]),_:1}),t(", and "),l(i,{to:"/docs/getting-started/glossary#fields"},{default:o(()=>[t("Fields")]),_:1}),t(".")])]),e("div",x,[f,e("p",null,[t("This page details Importing and Exporting of Items as files via the no-code app. However, you can also "),l(i,{to:"/docs/reference/system/utilities#import-data-from-file"},{default:o(()=>[t("Import")]),_:1}),t(" and "),l(i,{to:"/docs/reference/system/utilities#export-data-to-a-file"},{default:o(()=>[t("Export")]),_:1}),t(" Items as files programmatically via the API.")])]),_,g,y,w,I,b,v,F,C,E,k,L,T,S,A,D,M,N,U,e("p",null,[t("To import and export files, please see the "),l(i,{to:"/docs/app/file-library"},{default:o(()=>[t("File Library Module")]),_:1}),t(".")]),V])]),_:1})}}};export{X as default,J as description,W as modularExtension,R as readTime,j as title};
