import{a as i,o as d,e as u,y as t,u as e,q as l,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const h={class:"markdown-body"},c=e("blockquote",null,[e("p",null,[l("Insights is a Module in Directus that allows rapid, no-code build-out of analytics dashboards. Regardless of your use-case "),e("em",null,"(be it business intelligence, user progress tracking, web traffic conversions, or whatever!)"),l(" you will be able to setup key data metrics in just a few clicks.")])],-1),p=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/insights-dashboards-20220216A.mp4",type:"video/mp4"})],-1),g=e("h2",{id:"how-it-works",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-it-works"},"#"),l(" How it Works")],-1),m=e("video",{autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/insights-how-it-works-20220216A_1.mp4",type:"video/mp4"})],-1),b=e("p",null,"First, create a Dashboard, then fill the Dashboard with Panels.",-1),y=e("ol",null,[e("li",null,[l("Click the \u201CCreate Dashboard\u201D action button "),e("span",{mi:"",btn:""},"add"),l(" in the page header.")]),e("li",null,"Fill in the dashboard name, icon and note."),e("li",null,"Click \u201CSave\u201D."),e("li",null,"Click the edit icon in the page header."),e("li",null,[l("Hit the \u201CCreate Panel\u201D "),e("span",{mi:"",btn:""},"add"),l(" in the page header.")]),e("li",null,[l("Select a Panel type. "),e("a",{href:"#panels-overview"},"Learn More about panel types"),l(".")]),e("li",null,"Adjust the Panel Options to customize the analytics metric."),e("li",null,[l("Click "),e("span",{mi:"",btn:""},"check"),l(" in the drawer header to create the panel.")]),e("li",null,[l("Click "),e("span",{mi:"",btn:""},"check"),l(" in the page header to confirm all edits.")])],-1),f=e("h2",{id:"dashboards-overview",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#dashboards-overview"},"#"),l(" Dashboards Overview")],-1),_=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/dashboards-overview-20220216A.webp",alt:"Dashboard Grid Area"})],-1),v={class:"tip hint"},w=e("div",{class:"hint-title"},"Auto Refresh",-1),S=e("h2",{id:"create%2C-edit%2C-and-delete-dashboards",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#create%2C-edit%2C-and-delete-dashboards"},"#"),l(" Create, Edit, and Delete Dashboards")],-1),x=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/create-edit-delete-dashboards-20220216A.webp",alt:"How to Add, Edit and Delete Dashboards in Directus Insights"})],-1),D=e("ol",null,[e("li",null,[l("Click the "),e("span",{mi:"",btn:""},"add"),l(" icon in the page header to create a new Dashboard.")]),e("li",null,"Click the item option to edit or delete a Dashboard.")],-1),A=e("h2",{id:"panels-overview",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#panels-overview"},"#"),l(" Panels Overview")],-1),I=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/panels-overview-20220216A.webp",alt:"Directus Dashboard Panels"})],-1),k=e("p",null,"Panels are the building-blocks we add onto Insights dashboards to create, save and display data analytics. There are five types of Panels, and each one provides some unique analytics tool.",-1),F=e("ol",null,[e("li",null,[e("strong",null,"Label"),l(" \u2013 Displays simple header text to describe other groups of panels. Doesn\u2019t actually provide data analysis.")]),e("li",null,[e("strong",null,"List"),l(" \u2013 Sortable, filterable list of items within a collection.")]),e("li",null,[e("strong",null,"Metric"),l(" \u2013 Sortable, filterable single-number metrics like sum, average, minimum and maximum, or first and last.")]),e("li",null,[e("strong",null,"Time Series"),l(" \u2013 Graph to display how metrics change over time. Provides same sorting, filtering and aggregation features seen in the list and metric panels.")]),e("li",null,[e("strong",null,"Global Variables"),l(" \u2014 Sets a variable which is globally accessible across other panels.")])],-1),C=e("h2",{id:"panel-header-options",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#panel-header-options"},"#"),l(" Panel Header Options")],-1),P=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/panel-header-options-20220216A.webp",alt:"Panel Header Options"})],-1),T=e("p",null,"All 4 panel types let you set custom text to provide quick and clear context about what a Panel represents. Panel Header options are exactly the same for all four Panel types. Headers are also totally optional and can be hidden.",-1),V=e("ul",null,[e("li",null,[e("strong",null,"Visible"),l(" \u2013 Determines if the header is visible or not.")]),e("li",null,[e("strong",null,"Name"),l(" \u2013 Sets a name in the header area.")]),e("li",null,[e("strong",null,"Icon"),l(" \u2013 Sets a small icon by the name.")]),e("li",null,[e("strong",null,"Color"),l(" \u2013 Sets a color for the icon.")]),e("li",null,[e("strong",null,"Note"),l(" \u2013 Sets a short description of the icon.")])],-1),L=e("h2",{id:"labels",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#labels"},"#"),l(" Labels")],-1),M=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/label-panel-options-20220216A.webp",alt:"Label Panel Options"})],-1),G=e("p",null,[l("As the name implies, this panel simply allows you to "),e("em",null,"label"),l(" a group of other panels. Labels do not provide analytics. Labels simply help visually group the other panels ("),e("em",null,"which do provide analytics"),l(") and give context to your dashboard.")],-1),O=e("ul",null,[e("li",null,[e("strong",null,"Label"),l(" \u2013 Sets the label text.")]),e("li",null,[e("strong",null,"Color"),l(" \u2013 Sets the label text color.")])],-1),q=e("h2",{id:"lists",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#lists"},"#"),l(" Lists")],-1),H=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/list-panel-options-20220216A.webp",alt:"List Panel Options"})],-1),R=e("p",null,[l("List panels display some number of Items from a Collection, "),e("em",null,"as a list!"),l(" These Items displayed can be filtered by other criteria as well. So for example, you could show your top 5 selling products, 3 worst performing sales regions, 10 students with the highest GPA "),e("em",null,"that are also"),l(" in intramural sports, or create any other kind of ranked and/or filtered list that could be generated from your dataset.")],-1),Y=e("ul",null,[e("li",null,[e("strong",null,"Collection"),l(" \u2013 Selects the Collection to rank.")]),e("li",null,[e("strong",null,"Limit"),l(" \u2013 Limits the number of Items that will appear in the Dashboard.")]),e("li",null,[e("strong",null,"Sort Field"),l(" \u2013 Sets the Collection Field you wish to order results by.")]),e("li",null,[e("strong",null,"Sort Direction"),l(" \u2013 Sets Items to display in ascending or descending order.")]),e("li",null,[e("strong",null,"Display Template"),l(" \u2013 Defines how List Items will be represented. Allows use of Field Item values as well as custom text.")]),e("li",null,[e("strong",null,"Filter"),l(" \u2013 Sets filters to only consider and rank Items that meet some criteria.")])],-1),N=e("h2",{id:"metrics",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#metrics"},"#"),l(" Metrics")],-1),W=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/metric-panel-options-20220216A.webp",alt:"Metrics Panel Options"})],-1),z=e("p",null,"Metrics Panels allow you to aggregate all Items in a Field down to a single value.",-1),E=e("ul",null,[e("li",null,[e("strong",null,"Collection"),l(" \u2013 Selects the Collection.")]),e("li",null,[e("strong",null,"Field"),l(" \u2013 Selects the Field to run aggregate function on.")]),e("li",null,[e("strong",null,"Aggregate Function"),l(" \u2013 Selects the type of aggregate to perform.")]),e("li",null,[e("strong",null,"Sort Field"),l(" \u2013 Sets the collection field you wish to order results by.")]),e("li",null,[e("strong",null,"Filter"),l(" \u2013 Sets filters to only run metrics on Items that meet some criteria.")])],-1),B=e("h3",{id:"more-on-aggregate-functions",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#more-on-aggregate-functions"},"#"),l(" More on Aggregate Functions")],-1),K=e("p",null,"Generally speaking, aggregate functions take a list of values and returns one single value.",-1),U=e("ul",null,[e("li",null,[e("strong",null,"Count"),l(" \u2013 Counts the number of Items in a Field.")]),e("li",null,[e("strong",null,"Count (Distinct)"),l(" \u2013 Counts the number of "),e("em",null,"unique"),l(" Items in a field.")]),e("li",null,[e("strong",null,"Average"),l(" \u2013 Averages values of all Items in a Field.")]),e("li",null,[e("strong",null,"Average (Distinct)"),l(" \u2013 Averages values of all "),e("em",null,"unique"),l(" Items in a Field.")]),e("li",null,[e("strong",null,"Sum"),l(" \u2013 Sums the values of all Items in a Field.")]),e("li",null,[e("strong",null,"Sum (Distinct)"),l(" \u2013 Sums the values of all "),e("em",null,"unique"),l(" Items in a Field.")]),e("li",null,[e("strong",null,"Minimum"),l(" \u2013 Selects the lowest valued Item in a Field.")]),e("li",null,[e("strong",null,"Maximum"),l(" \u2013 Selects the highest valued Item in a Field.")]),e("li",null,[e("strong",null,"First"),l(" \u2013 Selects the first Item out of all Items in a Field.")]),e("li",null,[e("strong",null,"Last"),l(" \u2013 Selects the last Item out of all Items in a Field.")])],-1),j=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"First, Last, Minimum and Maximum"),e("p",null,"First, Last, Minimum and Maximum are not aggregates in the purely mathematical sense of the word. However, they are placed in this panel option because they return one single Item.")],-1),J=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Why are some Fields grayed out?"),e("p",null,[l("Certain Fields cannot be used with certain aggregate functions. For example, you cannot use the average function on Fields that store text, because text cannot be averaged. When there is a conflict between panel options, Fields will be grayed out and unselectable in the "),e("code",null,"field dropdown list"),l(".")])],-1),X=e("h3",{id:"style-and-format-options",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#style-and-format-options"},"#"),l(" Style and Format Options")],-1),Q=e("ul",null,[e("li",null,[e("strong",null,"Abbreviate Value"),l(" \u2013 Abbreviates large numbers with a letter "),e("em",null,"(e.g. 2,000 = 2K)"),l(".")]),e("li",null,[e("strong",null,"Decimals"),l(" \u2013 Changes the number of decimals displayed.")]),e("li",null,[e("strong",null,"Prefix"),l(" \u2013 Adds text before the aggregate metric.")]),e("li",null,[e("strong",null,"Suffix"),l(" \u2013 Adds text after the aggregate metric.")]),e("li",null,[e("strong",null,"Conditional Styles"),l(" \u2013 Changes color of number displayed if it is "),e("code",null,">"),l(", "),e("code",null,">="),l(", "),e("code",null,"<"),l(", "),e("code",null,"<="),l(", "),e("code",null,"=="),l(", or "),e("code",null,"!="),l(" to some defined value.")])],-1),Z=e("h2",{id:"time-series",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#time-series"},"#"),l(" Time Series")],-1),$=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-20220216A/time-series-panel-options-20220216A.webp",alt:"Time Series Panel Options"})],-1),ee=e("p",null,"The Time Series Panel allows you to build graphs and see how data changes over time.",-1),le=e("ul",null,[e("li",null,[e("strong",null,"Collection"),l(" \u2013 Selects the Collection you want to analyze.")]),e("li",null,[e("strong",null,"Color"),l(" \u2013 Sets color of your graph curve.")]),e("li",null,[e("strong",null,"Group Aggregation"),l(" \u2013 Selects the type of aggregation to perform. "),e("a",{href:"#more-on-aggregate-functions"},"Learn more"),l(".")]),e("li",null,[e("strong",null,"Group Precision"),l(" \u2013 Sets the time interval to aggregate by "),e("em",null,"(days, weeks, months, etc.)"),l(".")]),e("li",null,[e("strong",null,"Date Field"),l(" \u2013 Selects the datetime Field used along the x-axis.")]),e("li",null,[e("strong",null,"Date Range"),l(" \u2013 Sets the time range from which data should be displayed, can be customized.")]),e("li",null,[e("strong",null,"Value Field"),l(" \u2013 Sets the Field you wish to aggregate.")]),e("li",null,[e("strong",null,"Value Decimals"),l(" \u2013 Changes the number of decimals displayed on the y-axis.")]),e("li",null,[e("strong",null,"Min Value"),l(" \u2013 Sets minimum value displayed on y-axis.")]),e("li",null,[e("strong",null,"Max Value"),l(" \u2013 Sets maximum value displayed on y-axis.")]),e("li",null,[e("strong",null,"Curve Type"),l(" \u2013 Sets curve to be shown as smooth, straight or stepline.")]),e("li",null,[e("strong",null,"Fill Type"),l(" \u2013 Sets fill type under curve to gradient, solid, or none.")]),e("li",null,[e("strong",null,"Filter"),l(" \u2013 Allows filtering of Items considered for analysis based on logical conditions.")]),e("li",null,[e("strong",null,"Show X-axis"),l(" \u2013 Toggles display of time along X-axis.")]),e("li",null,[e("strong",null,"Show Y-axis"),l(" \u2013 Toggles display of numeric values along Y-axis.")])],-1),te=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Time-oriented metrics only"),e("p",null,"In order to use this Panel, your Collection will need a datetime Field.")],-1),se=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Custom Date Range"),e("p",null,[l("Note that "),e("code",null,"Past"),l(" is not prefixed to a custom range as it is on the default ranges. When selecting "),e("strong",null,"\u201COther\u201D"),l(", simply type in "),e("code",null,"3 years"),l(", "),e("code",null,"1 month"),l(", "),e("code",null,"2 weeks"),l(", "),e("code",null,"5 days"),l(", etc.")])],-1),ae=e("h2",{id:"global-variable",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#global-variable"},"#"),l(" Global Variable")],-1),ie=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/app-guide/insights/insights-220624A/global-variable-220624A.webp",alt:"Global Variables"})],-1),ne=e("ul",null,[e("li",null,[e("strong",null,"Variable Key"),l(" \u2014 Sets your variable. Use this key to access the variable in other Insights panels.")]),e("li",null,[e("strong",null,"Type"),l(" \u2014 Sets the data type of your variable.")]),e("li",null,[e("strong",null,"Default Value"),l(" \u2014 Sets a default value for the global variable.")]),e("li",null,[e("strong",null,"Interface"),l(" \u2014 Selects the Interface to be used.")]),e("li",null,[e("strong",null,"Options"),l(" \u2014 Sets the Interface Options.")])],-1),oe=e("p",null,"This panel allows you to create a variable which is globally accessible across other panels. You can use this to do things like create a string or number to prefix other Insights Panel titles or pass it as a value into a Filter to query results.",-1),re=e("p",null,[l("To create and assign a Global Variable, follow the steps from "),e("a",{href:"#how-it-works"},"How it Works"),l(", selecting the Global Variable panel. Wrap the variable key in double-moustache syntax to access and assign it throughout other Insights Panels:")],-1),de=e("pre",null,[e("code",null,`{{ your_variable_key }}
`)],-1),ue=e("p",null,"You will notice that the Global Variable Panel is an interface in the Dashboard, allowing you to modify the value of this variable. If you change its value, all panels referencing the variable will update automatically.",-1),he=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Must be Valid Data Type"),e("p",null,"Your variable\u2019s data type will need to be a valid match to wherever you are using it. For example, do not apply a string or JSON variable in a place that requires Datetime data.")],-1),ce=e("h2",{id:"global-relational-variable",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#global-relational-variable"},"#"),l(" Global Relational Variable")],-1),pe=e("ul",null,[e("li",null,[e("strong",null,"Variable Key"),l(" \u2014 Sets your variable. Use this key to access the variable in other Insights panels.")]),e("li",null,[e("strong",null,"Collection"),l(" \u2014 The collection to get the item IDs from.")]),e("li",null,[e("strong",null,"Multiple"),l(" \u2014 Allow selection of multiple items when enabled.")]),e("li",null,[e("strong",null,"Limit"),l(" \u2014 Limits the number of items that can be selected.")]),e("li",null,[e("strong",null,"Display Template"),l(" \u2014 Defines how the items will be represented. Allows use of Field Item values as well as custom text.")]),e("li",null,[e("strong",null,"Filter"),l(" \u2014 Sets filters to allow selection of items that meet some criteria.")])],-1),ge=e("p",null,"This panel allows you to create a variable which is globally accessible across other panels. You can use this to do things like select single or multiple items and pass their IDs as a value into a Filter to query results.",-1),me=e("p",null,[l("To create and assign a Global Relational Variable, follow the steps from "),e("a",{href:"#how-it-works"},"How it Works"),l(", selecting the Global Relational Variable panel. Wrap the variable key in double-moustache syntax to access and assign it throughout other Insights Panels:")],-1),be=e("pre",null,[e("code",null,`{{ your_variable_key }}
`)],-1),ye=e("p",null,"You will notice that the Global Relational Variable Panel is an interface in the Dashboard, allowing you to modify the value of this variable. If you change its value, all panels referencing the variable will update automatically.",-1),fe=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Must be Valid Data Type"),e("p",null,"Your variable\u2019s data type will need to be a valid match to wherever you are using it. For example, do not apply a string or JSON variable in a place that requires Datetime data.")],-1),xe="Insights",De=!1,Ae="Insights is a Module in Directus that allows rapid, no-code build-out of analytics dashboards.",Ie="9 min read",ke={__name:"insights",setup(_e,{expose:o}){const s={title:"Insights",modularExtension:!1,description:"Insights is a Module in Directus that allows rapid, no-code build-out of analytics dashboards.",readTime:"9 min read"};return o({frontmatter:s}),(ve,we)=>{const a=i("router-link"),r=i("docs-wrapper");return d(),u(r,{frontmatter:s},{default:t(()=>[e("div",h,[c,p,g,m,b,y,f,_,e("p",null,[l("Each Directus Dashboard provides a drag-and-drop canvas where you can create and arrange different Panels to easily build out customized analytics. The Dashboard area automatically expands as you add more and more Panels. In theory, a Dashboard area can expand infinitely large\u2026 but in practice, users will probably only want to build Dashboards as large as the screen they will be viewing on. You are able to create as many Dashboards as you need. Additionally, the Dashboard view, edit, and create permissions are "),n(a,{to:"/docs/configuration/users-roles-permissions"},{default:t(()=>[l("fully configurable")]),_:1}),l(" by User Role.")]),e("div",v,[w,e("p",null,[l("The Auto Refresh menu in the "),n(a,{to:"/docs/app/overview#_4-sidebar"},{default:t(()=>[l("Sidebar")]),_:1}),l(" lets you select an interval to refresh dashboard data.")])]),S,x,D,A,I,k,F,C,P,T,V,L,M,G,O,q,H,R,Y,N,W,z,E,B,K,U,j,J,X,Q,Z,$,ee,le,te,se,ae,ie,ne,oe,re,de,ue,he,ce,pe,ge,me,be,ye,fe])]),_:1})}}};export{ke as default,Ae as description,De as modularExtension,Ie as readTime,xe as title};
