import{a as r,o as c,e as u,y as s,u as e,q as t,z as l}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},h=e("p",null,[t("Heya! Welcome to Directus, and thank you for taking the time to contribute back to Open Source Software! \u2764\uFE0F We want everybody to be able to contribute to Directus, no matter your background or expertise. In order to facilitate that, we\u2019ve put together a couple tips and tricks below. Our team truly appreciates every single contributor, community member, GitHub star, pull-request, bug report, and feature request. Keeping Directus completely free and open-source is our way of saying: "),e("strong",null,"Thank you!")],-1),p=e("blockquote",null,[e("p",null,"We\u2019re here to help!"),e("p",null,[t("If you have "),e("em",null,"any"),t(" questions along your contributor journey, please feel free to come chat with us on "),e("a",{href:"https://directus.chat",target:"_blank",rel:"noopener noreferrer"},"our Discord server"),t(".")])],-1),f=e("h2",{id:"code-of-conduct",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#code-of-conduct"},"#"),t(" Code of Conduct")],-1),m=e("p",null,[e("strong",null,[t("The Directus "),e("a",{href:"https://github.com/directus/directus/blob/main/code_of_conduct.md",target:"_blank",rel:"noopener noreferrer"},"Code of Conduct"),t(" is one of the ways we put our values into practice. We expect all of our staff, contractors and contributors to know and follow this code.")])],-1),g=e("p",null,[e("strong",null,"Our contributors and maintainers work extremely hard to build Directus as premium open-source software. Please be respectful of those efforts throughout our ecosystem. Trolling, harassing, insulting, or other unacceptable behavior by participants will not be tolerated.")],-1),b=e("p",null,"In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, religion, or sexual identity and orientation.",-1),_=e("p",null,"Examples of behavior that contributes to creating a positive environment include:",-1),y=e("ul",null,[e("li",null,"Using welcoming and inclusive language"),e("li",null,"Being respectful of differing viewpoints and experiences"),e("li",null,"Gracefully accepting constructive criticism"),e("li",null,"Focusing on what is best for the community"),e("li",null,"Showing empathy towards other community members")],-1),w=e("p",null,[e("strong",null,[t("Before continuing, please take a moment to read our full "),e("a",{href:"https://github.com/directus/directus/blob/main/code_of_conduct.md",target:"_blank",rel:"noopener noreferrer"},"Code of Conduct"),t(".")])],-1),v=e("h2",{id:"ways-to-contribute",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#ways-to-contribute"},"#"),t(" Ways to Contribute")],-1),k=e("h3",{id:"reporting-bugs",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#reporting-bugs"},"#"),t(" Reporting Bugs")],-1),x=e("p",null,[t("If you happen to run into a bug, please post an Issue on our main GitHub Issue board: "),e("a",{href:"https://github.com/directus/directus/issues",target:"_blank",rel:"noopener noreferrer"},"https://github.com/directus/directus/issues")],-1),D=e("p",null,"Please be as explicit and detailed as you can in the bug report. The more information available, the easier it is for other contributors to help you find the solution or fix. Consider adding a schema snapshot file, or a database dump.",-1),q=e("h3",{id:"leaving-feedback",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#leaving-feedback"},"#"),t(" Leaving Feedback")],-1),I=e("p",null,[t("If you have a great idea for an improvement of the platform, or any other feedback, please make sure to open a new Discussion on our GitHub Discussions board: "),e("a",{href:"https://github.com/directus/directus/discussions",target:"_blank",rel:"noopener noreferrer"},"https://github.com/directus/directus/discussions")],-1),T=e("h3",{id:"document-the-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#document-the-project"},"#"),t(" Document the Project")],-1),C=e("p",null,[t("The "),e("a",{href:"https://github.com/directus/docs",target:"_blank",rel:"noopener noreferrer"},"Directus Docs"),t(" are living documents that can always be improved on. Notice any parts of the docs in dire need of some tender love and care? Feel free to open a Pull Request!")],-1),B=e("h3",{id:"helping-others",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#helping-others"},"#"),t(" Helping Others")],-1),W=e("p",null,[t("The Directus community is growing quickly, which also means there\u2019s more and more people that have questions. Helping out your fellow developers by answering questions on "),e("a",{href:"https://directus.chat",target:"_blank",rel:"noopener noreferrer"},"Discord"),t(" or "),e("a",{href:"https://github.com/directus/directus/discussions/categories/q-a",target:"_blank",rel:"noopener noreferrer"},"GitHub Discussions"),t(" is a great way to help the project.")],-1),F=e("h3",{id:"pull-requests",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#pull-requests"},"#"),t(" Pull Requests")],-1),H=e("h4",{id:"bug-fixes",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#bug-fixes"},"#"),t(" Bug Fixes")],-1),P=e("p",null,"We treat Issues on the main repo as actionable items we want to get done. This also means that we welcome PRs for any Issue that has been labeled either \u201CBug\u201D, \u201CImprovement\u201D, or \u201CNew Feature\u201D. Labeled issues are bugs or new features that have been triaged, accepted, and are ready to be implemented.",-1),N=e("h4",{id:"implementing-features",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#implementing-features"},"#"),t(" Implementing Features")],-1),R=e("p",null,"With the continuous growth of Directus, more and more people are relying on Directus for (critical) data workloads in various use cases. This means we need to be careful with any changes that might affect the stability, security, performance, or scalability of Directus. For this reason, it\u2019s important that any new feature is properly thought through and discussed before being implemented.",-1),j=e("p",null,"Before you start writing code to implement your new feature idea, please read through and understand our triaging process for new features before diving in. While we encourage and appreciate every code contribution, please understand that we can\u2019t merge every suggested code change.",-1),G=e("h5",{id:"triaging-process",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#triaging-process"},"#"),t(" Triaging Process")],-1),O=e("p",null,"Feature Request Discussions that are deemed ready to be implemented with the discussed implementation details are marked \u201CAccepted\u201D and converted into an Issue, at which point the feature is ready to be implemented.",-1),S=e("p",null,[t("New feature ideas reported directly to issues might be converted into a Discussion for further triaging at "),e("a",{href:"https://github.com/orgs/directus/people",target:"_blank",rel:"noopener noreferrer"},"the core team"),t("\u2019s discretion first. This is often due to a lack of detail, or lack of proven interest.")],-1),A=e("p",null,[t("Each Pull Request that comes in is required to resolve "),e("a",{href:"https://github.com/directus/directus/issues",target:"_blank",rel:"noopener noreferrer"},"an open Issue"),t(" that is labeled \u201CBug\u201D, \u201CImprovement\u201D, or \u201CNew Feature\u201D. This ensures that any code change made implements a known actionable item, be it a feature or otherwise.")],-1),E=e("h3",{id:"reporting-security-vulnerabilities",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#reporting-security-vulnerabilities"},"#"),t(" Reporting Security Vulnerabilities")],-1),V=e("a",{href:"https://github.com/directus/directus/security/advisories",target:"_blank",rel:"noopener noreferrer"},"GitHub Security Advisory",-1),z=e("p",null,"We value the members of the independent security research community who find security vulnerabilities and work with our team so that proper fixes can be issued to users. Our policy is to credit all researchers in the fix\u2019s release notes. In order to receive credit, security researchers must follow responsible disclosure practices, including:",-1),L=e("ul",null,[e("li",null,"They do not publish the vulnerability prior to the Directus team releasing a fix for it"),e("li",null,"They do not divulge exact details of the issue, e.g., through exploits or proof-of-concepts")],-1),Q="Contributing",X=!1,Y="An introduction to the process, rules and guidelines that for all code contributions to Directus.",Z="6 min read",$={__name:"introduction",setup(K,{expose:i}){const o={title:"Contributing",modularExtension:!1,description:"An introduction to the process, rules and guidelines that for all code contributions to Directus.",readTime:"6 min read"};return i({frontmatter:o}),(U,J)=>{const n=r("router-link"),a=r("docs-wrapper");return c(),u(a,{frontmatter:o},{default:s(()=>[e("div",d,[h,p,f,m,g,b,_,y,w,v,k,x,D,q,I,T,C,B,W,F,H,P,N,R,j,G,O,S,A,E,e("p",null,[t("If you believe you have discovered a security issue within a Directus product or service, please reach out to us directly over email: "),l(n,{to:"/docsmailto:security@directus.io"},{default:s(()=>[t("security@directus.io")]),_:1}),t(". We will then open a "),V,t(" for tracking the fix.")]),z,L])]),_:1})}}};export{$ as default,Y as description,X as modularExtension,Z as readTime,Q as title};
