import{a as i,o as c,e as d,y as s,u as e,q as t,z as a}from"./runtime-core.esm-bundler.22ec0346.js";const u={class:"markdown-body"},h=e("blockquote",null,[e("p",null,"Presets are items which store the state of a Collection Page. This allows you to set layout defaults or define bookmarks to specific datasets.")],-1),p={class:"tip hint"},m=e("div",{class:"hint-title"},"Before You Begin",-1),_={class:"tip hint"},f=e("div",{class:"hint-title"},"Learn More",-1),k=e("code",null,"directus_activity",-1),g=e("code",null,"directus_files",-1),y=e("code",null,"directus_users",-1),v=e("p",null,[t("Admins can access and manage all presets under "),e("strong",null,"Settings > Presets and Bookmarks"),t(".")],-1),b=e("h2",{id:"create-a-preset",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#create-a-preset"},"#"),t(" Create a Preset")],-1),w=e("video",{title:"Create a Preset",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/presets-bookmarks/presets-bookmarks-20220819/create-a-preset-20220819B.mp4",type:"video/mp4"})],-1),P=e("p",null,"There are two types or presets, Defaults and Bookmarks.",-1),C=e("p",null,[t("A "),e("em",null,"Default"),t(" determines how a user will initially view a Collection Page. When a user makes adjustments to a given Collection Page, these are automatically saved as the Default, so the adjustments remain even if the user navigates away and then returns.")],-1),B=e("em",null,"Bookmark",-1),T=e("p",null,[t("The method to create a preset shown here is for Admin use only. For Administrators, the process to create either a Default or a Bookmark is almost exactly the same. The key difference is that if you set a value for "),e("strong",null,"Name"),t(", the preset becomes a Bookmark. If "),e("strong",null,"Name"),t(" is left blank, the preset will be a Default. To create a preset, follow these steps.")],-1),N=e("li",null,[t("Navigate to "),e("strong",null,"Settings > Presets & Bookmarks"),t(".")],-1),S=e("li",null,[t("Click "),e("span",{mi:"",btn:""},"add"),t(" in the header.")],-1),x=e("li",null,[e("strong",null,"Collection"),t(" \u2014 Sets the collection this preset will apply to. Notice the layout preview below, which populates with live data from the selected collection.")],-1),D=e("li",null,[e("strong",null,"Scope"),t(" \u2014 Defines which users have access to this preset.")],-1),j=e("li",null,[e("strong",null,"Layout"),t(" \u2014 Selects a Layout for the preset, which is adjusted from the Sidebar.")],-1),A=e("strong",null,"Name",-1),L=e("li",null,[t("Scroll down to the "),e("strong",null,"Layout Preview"),t(" section and make any other adjustments or configurations as desired. Each preset saves all of the information needed to recreate this Layout Preview, just as it is shown.")],-1),E=e("li",null,[t("Click "),e("span",{mi:"",btn:""},"check"),t(" to confirm.")],-1),I=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Preset Priority"),e("p",null,"Multiple Defaults can be created for the same Collection Page for the same user. When this happens, the preset priority is: User, then Role, then Global.")],-1),q=e("h2",{id:"edit-a-preset",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#edit-a-preset"},"#"),t(" Edit a Preset")],-1),M=e("video",{title:"Edit a Preset",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/presets-bookmarks/presets-bookmarks-20220819/edit-a-preset-20220819A.mp4",type:"video/mp4"})],-1),R=e("ol",null,[e("li",null,[t("Navigate to "),e("strong",null,"Settings > Presets & Bookmarks > [preset]"),t(".")]),e("li",null,"Reconfigure your preset as desired."),e("li",null,[t("Click "),e("span",{mi:"",btn:""},"check"),t(" to confirm.")])],-1),V=e("h2",{id:"delete-a-preset",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#delete-a-preset"},"#"),t(" Delete a Preset")],-1),W=e("video",{title:"Delete a Preset",autoplay:"",playsinline:"",muted:"",loop:"",controls:""},[e("source",{src:"https://cdn.directus.io/docs/v9/configuration/presets-bookmarks/presets-bookmarks-20220819/delete-a-preset-20220819A.mp4",type:"video/mp4"})],-1),z=e("ol",null,[e("li",null,[t("Navigate to "),e("strong",null,"Settings > Presets & Bookmarks > [preset]"),t(".")]),e("li",null,[t("Click "),e("span",{mi:"",btn:"",dngr:""},"delete"),t(" in the page header and a popup will appear. Click "),e("strong",null,"Confirm"),t(".")])],-1),G=e("div",{class:"danger hint"},[e("div",{class:"hint-title"},"Irreversible Change"),e("p",null,"This action is permanent and cannot be undone. Please proceed with caution.")],-1),H="Presets",J=!1,K="Presets store the state of a Collection Page. They can be used to set layout defaults or define bookmarks to specific datasets.",O="3 min read",X={__name:"presets-bookmarks",setup(U,{expose:l}){const n={title:"Presets",modularExtension:!1,description:"Presets store the state of a Collection Page. They can be used to set layout defaults or define bookmarks to specific datasets.",readTime:"3 min read"};return l({frontmatter:n}),(Y,F)=>{const o=i("router-link"),r=i("docs-wrapper");return c(),d(r,{frontmatter:n},{default:s(()=>[e("div",u,[h,e("div",p,[m,e("p",null,[t("We recommend you read through the "),a(o,{to:"/docs/getting-started/quickstart.md"},{default:s(()=>[t("Quickstart Guide")]),_:1}),t(" to get an overview of the platform first, then see our guide on the "),a(o,{to:"/docs/app/content/collections.md"},{default:s(()=>[t("Collection Page")]),_:1}),t(" so you\u2019re familiar with its features and functionalities.")])]),e("div",_,[f,e("p",null,[t("To manage Presets and Bookmarks programmatically, see our "),a(o,{to:"/docs/reference/system/presets.md"},{default:s(()=>[t("API guide on Presets")]),_:1}),t(".")])]),e("p",null,[t("Remember, a "),a(o,{to:"/docs/app/content/collections.md"},{default:s(()=>[t("Collection Page")]),_:1}),t(" enables you to customize how its items are presented. That is, it lets you sort, search, or filter items and even change "),a(o,{to:"/docs/app/layouts.md"},{default:s(()=>[t("Layouts")]),_:1}),t(". In some cases, you may need to apply the same display adjustments again and again. Presets save these adjustments, like a snapshot. You can create presets for all project collections, as well as "),k,t(", "),g,t(" and "),y,t(".")]),v,b,w,P,C,e("p",null,[t("A "),B,t(" creates another custom display of the Collection Page, which can be accessed any time on the "),a(o,{to:"/docs/app/overview#_2-navigation-bar"},{default:s(()=>[t("Navigation Bar")]),_:1}),t(". Users can also "),a(o,{to:"/docs/app/content/collections.html#create-a-bookmark"},{default:s(()=>[t("create a Bookmark")]),_:1}),t(" for personal use from within the Content Module.")]),T,e("ol",null,[N,S,e("li",null,[t("Configure your preset item\u2019s values as desired: "),e("ul",null,[x,D,j,e("li",null,[A,t(" \u2014 Sets a name, which determines if the preset is a Default or Bookmark. Note that this field supports "),a(o,{to:"/docs/configuration/translation-strings.md"},{default:s(()=>[t("Translation Strings")]),_:1}),t(".")])])]),L,E]),I,q,M,R,V,W,z,G])]),_:1})}}};export{X as default,K as description,J as modularExtension,O as readTime,H as title};
