import{a,o as c,e as h,y as n,u as e,q as t,z as r}from"./runtime-core.esm-bundler.22ec0346.js";const d={class:"markdown-body"},u=e("em",null,"Development",-1),p=e("em",null,"Production",-1),m=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Minimum Requirements"),e("p",null,[t("You will need to have "),e("a",{href:"https://nodejs.org/en/download/current",target:"_blank",rel:"noopener noreferrer"},"the latest version of Node"),t(" to "),e("em",null,"build"),t(" a Development version of Directus.")]),e("p",null,[t("You can use the JavaScript tool manager "),e("a",{href:"https://volta.sh",target:"_blank",rel:"noopener noreferrer"},"volta"),t(" to automatically install the current node and npm versions.")]),e("p",null,[t("You will also need to have the package manager "),e("a",{href:"https://pnpm.io",target:"_blank",rel:"noopener noreferrer"},"pnpm"),t(" installed. You can install pnpm using the following command: "),e("code",null,"npm install -g pnpm"),t(".")])],-1),_=e("h2",{id:"1.-fork-the-directus-repository",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#1.-fork-the-directus-repository"},"#"),t(" 1. Fork the Directus repository")],-1),g=e("p",null,[t("Go to the "),e("a",{href:"https://github.com/directus/directus",target:"_blank",rel:"noopener noreferrer"},"repository"),t(" and fork it to your GitHub account. A fork is your copy of the Directus repository. Forking the repository allows you to freely experiment with changes without affecting the original project.")],-1),f=e("h2",{id:"2.-clone-from-your-repository",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#2.-clone-from-your-repository"},"#"),t(" 2. Clone from your repository")],-1),b=e("pre",null,[e("code",{class:"language-bash"},[t("git "),e("span",{class:"hljs-built_in"},"clone"),t(` git@github.com:YOUR-USERNAME/directus.git
`)])],-1),y=e("h2",{id:"3.-make-a-new-branch",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#3.-make-a-new-branch"},"#"),t(" 3. Make a new branch")],-1),k=e("pre",null,[e("code",{class:"language-bash"},`git checkout -b YOUR-BRANCH-NAME
`)],-1),v=e("h2",{id:"4.-install-the-dependencies-and-build-the-project",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#4.-install-the-dependencies-and-build-the-project"},"#"),t(" 4. Install the dependencies and build the project")],-1),w=e("pre",null,[e("code",{class:"language-bash"},`pnpm install
pnpm -r build
`)],-1),x=e("h2",{id:"5.-create-a-.env-file",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#5.-create-a-.env-file"},"#"),t(" 5. Create a "),e("code",null,".env"),t(" file")],-1),j=e("p",null,[t("Create an "),e("code",null,".env"),t(" file under the "),e("code",null,"api"),t(" folder using vars from the online "),e("a",{href:"https://docs.directus.io/self-hosted/config-options",target:"_blank",rel:"noopener noreferrer"},"config help")],-1),D=e("h2",{id:"6.-initialize-the-database",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#6.-initialize-the-database"},"#"),t(" 6. Initialize the database")],-1),A=e("p",null,"For this step, you\u2019ll need to already have a SQL database up-and-running, except if you\u2019re using the SQLite driver, which will create the database (file) for you.",-1),T=e("p",null,"To start the initialization run the following command:",-1),I=e("pre",null,[e("code",{class:"language-bash"},[e("span",{class:"hljs-comment"},"# Run the command in the 'api' context (to ensure the database file is created in the right directory)"),t(`
pnpm --`),e("span",{class:"hljs-built_in"},"dir"),t(` api cli bootstrap
`)])],-1),R=e("p",null,"This will set-up the required tables for Directus and make sure all the migrations have run.",-1),C=e("h2",{id:"7.-start-the-development-server",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#7.-start-the-development-server"},"#"),t(" 7. Start the development server")],-1),Y=e("p",null,"You can run all packages in development with the following command:",-1),E=e("pre",null,[e("code",{class:"language-bash"},`pnpm -r dev
`)],-1),N=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Race Conditions"),e("p",null,[t("When running multiple or all packages, sometimes "),e("code",null,"ts-node"),t(" may not start up the API properly because of race conditions due to changes happening to other packages. You can either rerun the command to restart the API or opt to choose what packages to work on as described below.")])],-1),P=e("p",null,[t("If you wish to choose what packages to work on, you should run the "),e("code",null,"dev"),t(" script for that package. You can see their names and list of scripts in their related "),e("code",null,"package.json"),t(".")],-1),S=e("p",null,"Example of running the API only:",-1),q=e("pre",null,[e("code",{class:"language-bash"},`pnpm --filter directus dev
`)],-1),z=e("p",null,"If you want to work on multiple packages at once, you should create a new instance of your terminal for each package. Example of running both the API and App at the same time:",-1),B=e("table",null,[e("tr",null,[e("th",null," Terminal 1 [Api] "),e("th",null," Terminal 2 [App] ")]),e("tr",null,[e("td",null,[e("pre",null,[e("code",{class:"language-bash"},`pnpm --filter directus dev
`)])]),e("td",null,[e("pre",null,[e("code",{class:"language-bash"},`pnpm --filter @directus/app dev
`)])])])],-1),F=e("hr",null,null,-1),M=e("p",null,[t("To work on the Documentation (public website version), you should clone the "),e("a",{href:"https://github.com/directus/docs",target:"_blank",rel:"noopener noreferrer"},[e("code",null,"directus/docs")]),t(" repository and run the following command:")],-1),H=e("pre",null,[e("code",{class:"language-bash"},`pnpm install
pnpm dev
`)],-1),L=e("div",{class:"tip hint"},[e("p",null,"If you encounter errors during this installation process, make sure your node version meets the minimum requirements")],-1),G=e("h2",{id:"8.-make-your-fixes%2Fchanges",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#8.-make-your-fixes%2Fchanges"},"#"),t(" 8. Make your fixes/changes")],-1),U=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Debugging"),e("p",null,[t("Check our Wiki for a "),e("a",{href:"https://github.com/directus/directus/wiki/debugging",target:"_blank",rel:"noopener noreferrer"},"guide"),t(" on debugging the app and API.")])],-1),V=e("h2",{id:"9.-running-tests",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#9.-running-tests"},"#"),t(" 9. Running tests")],-1),O=e("p",null,"Tests run automatically through GitHub Actions. However you may wish to run the tests locally especially when you write tests.",-1),Q=e("p",null,[t("Install "),e("a",{href:"https://docs.docker.com/get-docker",target:"_blank",rel:"noopener noreferrer"},"Docker"),t(" and ensure that the service is running.")],-1),W=e("pre",null,[e("code",{class:"language-bash"},[e("span",{class:"hljs-comment"},"# Ensure that you are testing on the lastest codebase"),t(`
pnpm -r build

`),e("span",{class:"hljs-comment"},"# Clean up in case you ran the tests before"),t(`
docker compose -f tests/docker-compose.yml down -v

`),e("span",{class:"hljs-comment"},"# Start the necessary containers"),t(`
docker compose -f tests/docker-compose.yml up -d --`),e("span",{class:"hljs-built_in"},"wait"),t(`

`),e("span",{class:"hljs-comment"},"# Run the tests"),t(`
pnpm `),e("span",{class:"hljs-built_in"},"test"),t(`:e2e
`)])],-1),$="Running Locally",ee=!1,te="This guide explains how to install the _Development_ version of Directus locally so that you can work on the platform's source code.",ne="4 min read",oe={__name:"running-locally",setup(J,{expose:l}){const o={title:"Running Locally",modularExtension:!1,description:"This guide explains how to install the _Development_ version of Directus locally so that you can work on the platform's source code.",readTime:"4 min read"};return l({frontmatter:o}),(K,X)=>{const s=a("router-link"),i=a("docs-wrapper");return c(),h(i,{frontmatter:o},{default:n(()=>[e("div",d,[e("blockquote",null,[e("p",null,[t("This guide explains how to install the "),u,t(" version of Directus locally so that you can work on the platform\u2019s source code. To install the "),p,t(" version locally, please follow to our "),r(s,{to:"/docs/self-hosted/installation"},{default:n(()=>[t("standard installation guides")]),_:1}),t(".")])]),m,_,g,f,b,y,k,v,w,x,j,D,A,T,I,R,C,Y,E,N,P,S,q,z,B,F,M,H,L,G,e("p",null,[t("At this point you are ready to start working on Directus! Before diving in however, it\u2019s worth reading through the introduction to "),r(s,{to:"/docs/contributing/introduction"},{default:n(()=>[t("Contributing")]),_:1}),t(".")]),U,V,O,Q,W])]),_:1})}}};export{oe as default,te as description,ee as modularExtension,ne as readTime,$ as title};
