import{a as s,o as d,e as c,y as a,u as e,q as t,z as n}from"./runtime-core.esm-bundler.22ec0346.js";const h={class:"markdown-body"},m=e("blockquote",null,[e("p",null,"A Team is an organizational system that groups Accounts together as Team Members and provides consolidated billing on its nested Projects.")],-1),u=e("p",null,"Teams within the Cloud Dashboard allow individuals to separate or consolidate Projects and payment methods, as well as manage Projects independently or with other Team Members.",-1),p=e("p",null,"For example, a company can use Teams to organize Projects by department, each with consolidated billing and scoped access. Similarly, agencies or freelancers with multiple customers can create a Team per client to limit their access and isolate billing. Teams are free, so create as many as you need to appropriately organize Team Members, Projects and payment methods.",-1),g=e("h2",{id:"create-a-team",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#create-a-team"},"#"),t(" Create a Team")],-1),b=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/create-a-team-20220329A.webp",alt:"Create Team"})],-1),_=e("p",null,"To create a Team:",-1),T=e("ol",null,[e("li",null,[t("Open the Team Menu in the Dashboard Header and click "),e("strong",null,[t("\u201CCreate a Team "),e("span",{mi:"",icon:"",prmry:""},"add"),t("\u201D")]),t("."),e("br"),t(" The Create Team page will open.")]),e("li",null,[t("Enter a Team Name and Team Slug, then click "),e("strong",null,"\u201CSave\u201D"),t(".")])],-1),y=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Team Name and Team Slug"),e("p",null,[t("The Team Name is a text name assigned to a Team, used in the Cloud Dashboard. The Team slug lies within the full URL "),e("code",null,"https://directus.cloud/TEAM-SLUG/projects"),t(". These are purely organizational, allowing you to easily remember the Team and link to specific Cloud Dashboards. They do not impact Cloud Projects or billing and can be "),e("a",{href:"#update-team-settings"},"updated at any time"),t(".")])],-1),v=e("h2",{id:"update-team-settings",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#update-team-settings"},"#"),t(" Update Team Settings")],-1),f=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/managing-a-team-20220225A.webp",alt:"Managing a Team"})],-1),w=e("p",null,"To update Team Settings:",-1),P=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CSettings\u201D"),t(" to enter the Team Settings page.")]),e("li",null,[t("Toggle "),e("span",{mi:"",icon:"",prmry:""},"edit"),t(" to allow edits.")]),e("li",null,"Edit Team Name and Team Slug as desired."),e("li",null,[t("Click the "),e("strong",null,"\u201CSave\u201D"),t(" button.")])],-1),A=e("h2",{id:"view-team-activity",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#view-team-activity"},"#"),t(" View Team Activity")],-1),j=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/view-team-activity-20220322A.webp",alt:"View Team Activity"})],-1),M=e("p",null,"The Team Activity Page displays billing information changes, created and destroyed Projects, Team Members added or removed, Team Name and Team Slug changes, and any other major Team-oriented activities. To view Team Activity:",-1),x=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CActivity\u201D"),t(".")])],-1),N=e("h2",{id:"view-billing-details",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#view-billing-details"},"#"),t(" View Billing Details")],-1),C=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/view-billing-details-20220322A.webp",alt:"View Billing Details"})],-1),k=e("p",null,"Follow these steps to see billing details such as credit available to Team Projects, total active subscriptions and invoice receipts:",-1),S=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CBilling\u201D"),t(" to enter the Billing Details Page.")])],-1),D=e("h2",{id:"manage-billing",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#manage-billing"},"#"),t(" Manage Billing")],-1),B=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/manage-billing-20220322A.webp",alt:"Manage Billing"})],-1),$=e("p",null,"Since our Community tier is completely free, and our Enterprise tier pricing is individually tailored based on customer needs, this section will focus on our pay-as-you-go Standard tier. Follow the steps below to change a default payment method, add or remove additional payment methods or change other billing details:",-1),I=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CBilling\u201D"),t(" to enter the Billing Details page.")]),e("li",null,[t("Click "),e("strong",null,"\u201CManage Billing\u201D"),t(" to enter the Stripe payments gateway.")]),e("li",null,"Adjust payment methods and details as needed."),e("li",null,[t("Click "),e("strong",null,"\u201CReturn to Directus Cloud\u201D"),t(".")])],-1),R=e("h3",{id:"team-billing",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#team-billing"},"#"),t(" Team Billing")],-1),O=e("p",null,[t("Teams are free to create, and they give Team Members access to the same Projects, Project invoices and payment methods. Each Team has its own separate billing, and each Project within a Team is "),e("a",{href:"#how-bills-are-calculated"},"calculated"),t(" and "),e("a",{href:"#billing-cycles"},"invoiced separately every month"),t(".")],-1),z=e("p",null,"Team Members are SuperAdmins. As such, they have full access to manage billing information and payment methods, including information provided by other Team Members. When creating Projects in an existing team, you can reuse existing team credit card on file. Team Members should be highly trusted individuals.",-1),H=e("p",null,"All bills will first be invoiced to the default payment method. You may notice that it is possible to add additional payment methods, and it may be a good idea to do so, as keeping multiple payment methods on file provides a fail-safe to help make sure your Project stays running. In the event that there is an issue processing the default payment method, the other payment methods on file will be attempted. If the bill is not paid, the Nodes will be paused, halting web-traffic, until a successful payment is made.",-1),V=e("div",{class:"warning hint"},[e("p",null,[t("If the paused Project is never repaid, it will eventually be deleted along with all of its data and assets. For details on unpaid Projects and refunds, see "),e("a",{href:"https://directus.io/cloud-policies",target:"_blank",rel:"noopener noreferrer"},"Cloud Policies")])],-1),E=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Team Metered Usage"),e("p",null,[t("You may notice credit on top of the "),e("a",{href:"#view-billing-details"},"Billing Page"),t(". In the "),e("em",null,"rare event"),t(" your Team receives credit from the Directus Team, this credit balance will decrease the amount due on the next invoice(s) until all credit is used up. Then the default payment method will be used.")])],-1),L=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Stripe Payment"),e("p",null,"To handle billing, Directus Cloud uses Stripe, a secure, industry-leading, dynamic international billing service.")],-1),F=e("h3",{id:"billing-cycles",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#billing-cycles"},"#"),t(" Billing Cycles")],-1),G=e("p",null,"Bills are invoiced on a calendar monthly basis, so each new billing period begins after exactly one month. When a Project is destroyed, the bill is processed immediately. As mentioned in the previous section, bills are invoiced per-Project; so if a Team has 4 Standard Projects, it will be charged 4 times each month.",-1),U=e("h3",{id:"how-bills-are-calculated",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#how-bills-are-calculated"},"#"),t(" How Bills Are Calculated")],-1),Y=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Node Pricing"),e("p",null,[e("strong",null,"Lite:"),t(" $0.03424657534 / hour"),e("br"),e("strong",null,"General Purpose Tier:"),t(" $0.06849315068 / hour")])],-1),q=e("p",null,[t("This means the monthly prices given for Reserved Nodes, "),e("em",null,"$25/month for Lite and $50/month for General Purpose tier"),t(", are actually estimates based on the cost per hour times the average length of a month (730 hours). So, the pricing shown for one Lite Node is "),e("code",null,"$0.03424657534 x 730hrs = $25"),t(", however the actual bill will vary slightly each month, based on the actual hours in the month.")],-1),W=e("p",null,[t("Keep in mind that a Standard Project\u2019s Nodes can be reconfigured at any time. You can upgrade and downgrade Node Types, add and remove Nodes, or destroy your Project as you please. In the end, "),e("em",null,"you simply pay for the actual Node-hours used by your Project"),t(".")],-1),K=e("p",null,"The following examples demonstrate this billing system:",-1),J=e("p",null,[e("strong",null,"Hourly Pricing"),e("br"),t(" A Project is configured to use one Lite Node. The Project runs for 3 days and 3.5 hours (75.5 hours total, rounded to 76 hours) and is then destroyed, costing "),e("code",null,"1 Node x $0.03424657534/hr x 76 hrs = $2.60"),t(".")],-1),Q=e("p",null,[t("The bill will be "),e("code",null,"$2.60"),t(" plus Tax/VAT, charged at Project destruction.")],-1),X=e("p",null,[e("strong",null,"Monthly Node Rates"),e("br"),t(" A Project is configured to use two General Purpose Tier Nodes. The Project runs the full month (730 hours). For this billing cycle, the two Reserved Nodes will cost "),e("code",null,"2 Nodes x $0.06849315068/hr x 730 hrs = $100"),t(".")],-1),Z=e("p",null,[t("The monthly bill will be "),e("code",null,"$100"),t(" plus Tax/VAT.")],-1),ee=e("p",null,[e("strong",null,"Pro-rated Changes"),e("br"),t(" A Project begins the billing cycle configured to use one Lite Node. A massive traffic spike is expected from marketing activities this month and 200 hours into the month, the Project is reconfigured to use five General Purpose Tier Nodes. The first 200 hours run the bill to "),e("code",null,"(1 Lite Node x $0.03424657534/hr x 200hrs) = $6.85"),t(". Then the other 530 hours add "),e("code",null,"(5 General Purpose Nodes x $0.06849315068/hr x 530hrs) = $181.51"),t(".")],-1),te=e("p",null,[t("The monthly bill will be "),e("code",null,"$188.36"),t(" plus VAT/Tax.")],-1),ae=e("h3",{id:"optimize-node-configuration",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#optimize-node-configuration"},"#"),t(" Optimize Node Configuration")],-1),ie=e("em",null,"you are never locked-in to a specific Node configuration",-1),ne=e("div",{class:"warning hint"},[e("div",{class:"hint-title"},"Reserved Nodes"),e("p",null,"For production-ready Projects of any kind, it is probably a good idea to have one or more than one Reserved Node. If you do not have the processing power to handle incoming traffic spikes, this can crash your Node!")],-1),oe=e("h2",{id:"invite-team-members",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#invite-team-members"},"#"),t(" Invite Team Members")],-1),se=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/inviting-a-team-member-20220225A.webp",alt:"Inviting a Team Member"})],-1),le=e("p",null,"All Team Members can invite new Members via email. Each invitee will be emailed a link to accept the invitation and join the Team. To invite Team Members:",-1),re=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CMembers\u201D"),t(" to enter the Members Page.")]),e("li",null,"Scroll down to the Invite New Members section."),e("li",null,"Enter one or more email(s), comma separated."),e("li",null,[t("Click "),e("strong",null,"\u201CSend Invites.\u201D")])],-1),de={class:"tip hint"},ce=e("h2",{id:"manage-team-members",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#manage-team-members"},"#"),t(" Manage Team Members")],-1),he=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/leaving-a-team-20220225A.webp",alt:"Removing a Team member"})],-1),me=e("p",null,"All Team Members have the ability to remove other Members or invites from a Team. To remove Members or leave a Team yourself:",-1),ue=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CMembers\u201D"),t(" to enter the Members Page.")]),e("li",null,[t("Click the "),e("span",{mi:"",icon:""},"exit_to_app"),t(" or "),e("span",{mi:"",icon:""},"close"),t(" button on the desired Member.")]),e("li",null,[t("Click "),e("strong",null,"\u201CConfirm\u201D"),t(".")])],-1),pe=e("div",{class:"warning hint"},[e("p",null,"If an Account leaves or is removed from a Team, it will be fully \u201Clocked out\u201D of the Team until re-invited by another Member.")],-1),ge=e("h2",{id:"destroy-a-team",tabindex:"-1"},[e("a",{class:"header-anchor",href:"#destroy-a-team"},"#"),t(" Destroy a Team")],-1),be=e("p",null,[e("img",{src:"https://cdn.directus.io/docs/v9/cloud/teams/teams-20220322A/destroy-a-team-20220225A.webp",alt:"Destroying a Team"})],-1),_e=e("p",null,"To destroy a Team:",-1),Te=e("ol",null,[e("li",null,"Open the Team Menu in the Dashboard Header and select the desired Team."),e("li",null,[t("Click "),e("strong",null,"\u201CSettings\u201D"),t(" to enter the Team Settings Page.")]),e("li",null,"Scroll down to the \u201CDestroy this Team\u201D section."),e("li",null,[t("Toggle "),e("span",{mi:"",icon:"",dngr:""},"local_fire_department"),t(" and an input box will appear.")]),e("li",null,"Type the Team Name into the input box."),e("li",null,[t("Click "),e("strong",null,"\u201CDestroy Team\u201D"),t(".")])],-1),ye=e("div",{class:"danger hint"},[e("p",null,"Destroying a Team completely removes all its data from Directus Cloud. This action is permanent and irreversible. Proceed with caution!")],-1),ve=e("div",{class:"tip hint"},[e("div",{class:"hint-title"},"Teams with Active Projects"),e("p",null,"To delete a Team, you must first delete any active Projects within it.")],-1),je="Cloud Teams",Me=!1,xe="A Team is an organizational system that groups Accounts together as Team Members and provides consolidated billing on its nested Projects.",Ne="10 min read",Ce={__name:"teams",setup(fe,{expose:l}){const o={title:"Cloud Teams",modularExtension:!1,description:"A Team is an organizational system that groups Accounts together as Team Members and provides consolidated billing on its nested Projects.",readTime:"10 min read"};return l({frontmatter:o}),(we,Pe)=>{const i=s("router-link"),r=s("docs-wrapper");return d(),c(r,{frontmatter:o},{default:a(()=>[e("div",h,[m,u,p,e("p",null,[t("See the "),n(i,{to:"/docs/cloud/overview"},{default:a(()=>[t("Overview")]),_:1}),t(" to learn how Accounts, Teams and Projects interrelate.")]),g,b,_,T,y,v,f,w,P,A,j,M,x,N,C,k,S,D,B,$,I,R,O,z,H,V,E,L,F,G,U,e("p",null,[t("Project billing is calculated based on the total number of hours that Reserved Nodes are used during the billing period. Once the "),n(i,{to:"/docs/cloud/glossary#nodes"},{default:a(()=>[t("Node Type")]),_:1}),t(" is selected, this applies to all Reserved Nodes.")]),Y,q,W,K,J,Q,X,Z,ee,te,ae,e("p",null,[t("Remember: "),ie,t(". As your needs change for a Project, you can reconfigure the Node Type as well as the number of Reserved Nodes at any time. To that end, you may want to monitor overall system traffic and make more-informed decisions on Node reconfiguration. The "),n(i,{to:"/docs/cloud/projects#monitor-a-project"},{default:a(()=>[t("Project Monitor Page")]),_:1}),t(" provides performance analytics, which can be used to help identify optimal Node configurations for your Project.")]),ne,oe,se,le,re,e("div",de,[e("p",null,[t("Clicking the emailed invitation link does not automatically create an Account for you. Invitees will need to "),n(i,{to:"/docs/cloud/accounts#create-account-and-login"},{default:a(()=>[t("create an Account")]),_:1}),t(" before accepting an invitation to join a Team.")])]),ce,he,me,ue,pe,ge,be,_e,Te,ye,ve])]),_:1})}}};export{Ce as default,xe as description,Me as modularExtension,Ne as readTime,je as title};
